﻿Public Class Benson

#Region "Declarations"

    'make static to share across all routines in this class
    Public Shared Fsp, Mmp, Qmp, Sd, Sdp, Sv, Xpmax, Cmp, Rmp, Vasp, Mdt As Double
    Public Shared Vbpa, apa, deltapa, Map, Catp, Fbtp, hpa, myp, Gammapa As Double
    Public Shared qpa, qalpa, qlppa, Qaspa, Qlspa, Qpspa, Qbspa, Qbsa As Double
    Public Shared a0pa, a1pa, a2pa, a3pa, a4pa, a5pa, b0pa, b1pa, b2pa As Double
    Public Shared d0pa, d1pa, d2pa, d3pa, e0pa, e1pa As Double
    Public Shared g3pa, g2pa, g1pa, h3pa, h2pa, h1pa, h0pa As Double
    Public Shared a0paz, a1paz, a2paz, a3paz, a4paz, a5paz As Double
    Public Shared h, B5, BM5, B4, BM4, B3, BM3, B2, BM2, B1, BM1, B0, BM0, alpha, beta, a_ab, b_ab, Qli, Qai, Qpi, Q_al, Q_lp, Q_ap, Q_lap As Double
    Public Const P0 As Double = 0.00002
    Public Shared One As Complex = toComplex(1, 0)

#End Region

#Region "Window Load and close"

    Private Sub Benson_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'This executes when the window loads:  just copy the data into the text boxes
        Color_Chooser.Color_set(Me)

        'Convert from Double to Single so they fit in the text boxes
        Fsp_TextBox.Text = Str(CSng(Fsp))
        Mmp_TextBox.Text = Str(CSng(Mmp))
        Qmp_TextBox.Text = Str(CSng(Qmp))
        Sdp_TextBox.Text = Str(CSng(Sdp))
        Xpmax_TextBox.Text = Str(CSng(Xpmax))
        Cmp_TextBox.Text = Str(CSng(Cmp))
        Rmp_TextBox.Text = Str(CSng(Rmp))
        Vasp_TextBox.Text = Str(CSng(Vasp))
        Vbpa_TextBox.Text = Str(CSng(Vbpa))
        apa_TextBox.Text = Str(CSng(apa))
        deltapa_TextBox.Text = Str(CSng(deltapa))
        Map_TextBox.Text = Str(CSng(Map))
        Catp_TextBox.Text = Str(CSng(Catp))
        Fbtp_TextBox.Text = Str(CSng(Fbtp))
        hpa_TextBox.Text = Str(CSng(hpa))
        myp_TextBox.Text = Str(CSng(myp))
        Gammapa_TextBox.Text = Str(CSng(Gammapa))

        qpa_TextBox.Text = Str(CSng(qpa))
        qalpa_TextBox.Text = Str(CSng(qalpa))
        qlppa_TextBox.Text = Str(CSng(qlppa))
        Qaspa_TextBox.Text = Str(CSng(Qaspa))
        Qlspa_TextBox.Text = Str(CSng(Qlspa))
        Qpspa_TextBox.Text = Str(CSng(Qpspa))
        Qbspa_TextBox.Text = Str(CSng(Qbspa))
        Qbsa_TextBox.Text = Str(CSng(Qbsa))
        a0pa_TextBox.Text = Str(CSng(a0pa))
        a1pa_TextBox.Text = Str(CSng(a1pa))
        a2pa_TextBox.Text = Str(CSng(a2pa))
        a3pa_TextBox.Text = Str(CSng(a3pa))
        a4pa_TextBox.Text = Str(CSng(a4pa))
        a5pa_TextBox.Text = Str(CSng(a5pa))
        b0pa_TextBox.Text = Str(CSng(b0pa))
        b1pa_TextBox.Text = Str(CSng(b1pa))
        b2pa_TextBox.Text = Str(CSng(b2pa))
        d0pa_TextBox.Text = Str(CSng(d0pa))
        d1pa_TextBox.Text = Str(CSng(d1pa))
        d2pa_TextBox.Text = Str(CSng(d2pa))
        d3pa_TextBox.Text = Str(CSng(d3pa))
        e0pa_TextBox.Text = Str(CSng(e0pa))
        e1pa_TextBox.Text = Str(CSng(e1pa))
        g3pa_TextBox.Text = Str(CSng(g3pa))
        g2pa_TextBox.Text = Str(CSng(g2pa))
        g1pa_TextBox.Text = Str(CSng(g1pa))
        h3pa_TextBox.Text = Str(CSng(h3pa))
        h2pa_TextBox.Text = Str(CSng(h2pa))
        h1pa_TextBox.Text = Str(CSng(h1pa))
        h0pa_TextBox.Text = Str(CSng(h0pa))
        a0paz_TextBox.Text = Str(CSng(a0paz))
        a1paz_TextBox.Text = Str(CSng(a1paz))
        a2paz_TextBox.Text = Str(CSng(a2paz))
        a3paz_TextBox.Text = Str(CSng(a3paz))
        a4paz_TextBox.Text = Str(CSng(a4paz))
        a5paz_TextBox.Text = Str(CSng(a5paz))
    End Sub

#End Region

#Region "Calculations"

    Public Sub Benson_init()
        'copy the driver and box data into the "standardized parameters" with the correct units
        Dim temp As Double  'used for interim values

        'Calculate Fsp (cell Benson!BH5 = Benson!BB5)
        temp = Derived.enclosure.PR.Fs
        If Derived.enclosure.Box_Type = Box_model.vented_box Then
            Fsp = 0.001
        Else
            Fsp = temp * Math.Sqrt(Derived.enclosure.PR.Mms / (Derived.enclosure.PR.Mms + Derived.enclosure.PR.Mass_added))
        End If

        'Mmp
        Mmp = Derived.enclosure.PR.Np * (Derived.enclosure.PR.Mms + Derived.enclosure.PR.Mass_added) * 0.001

        'Qmp
        If Derived.enclosure.Box_Type = Box_model.sealed_box Then
            Qmp = 0.0000001
        ElseIf Derived.enclosure.Box_Type = Box_model.vented_box Then
            Qmp = Derived.enclosure.Qp
        Else
            Qmp = Derived.enclosure.PR.Qms * Math.Sqrt((Derived.enclosure.PR.Mms + Derived.enclosure.PR.Mass_added) / Derived.enclosure.PR.Mms)
        End If

        'Sd
        'Sd = Derived.speaker.Sd * 0.0001 * Derived.speaker.Config.SdX
        Sd = Derived.Sd

        'Sv
        Sv = (Derived.enclosure.Vent.Dv * 0.0254 / 2) ^ 2 * Math.PI * Derived.enclosure.Vent.Nv

        'Sdp
        If Derived.enclosure.Box_Type = Box_model.PR_box Then
            Sdp = Derived.enclosure.PR.Sd * 0.0001 * Derived.enclosure.PR.Np
        Else
            Sdp = Sv
        End If

        'Xpmax
        Xpmax = Derived.enclosure.PR.Xmax * 0.001

        'Cmp
        'Cmp = 1000 / ((2 * Math.PI * Fsp) ^ 2 * Mmp)
        Cmp = 1 / ((2 * Math.PI * Fsp) ^ 2 * Mmp)




        'Rmp
        Rmp = 2 * Math.PI * Fsp * Mmp / Qmp

        'Vasp
        Vasp = Box_model.Rho0 * Box_model.Cair ^ 2 * Cmp * Sdp ^ 2 * 1000

        'Gammapa
        Gammapa = 1 + 0.9 / Derived.enclosure.Qa ^ 0.9

        'Vbpa
        Vbpa = Derived.Vb * Gammapa * 0.001

        'apa
        apa = Derived.Vas / Vbpa

        'deltapa
        deltapa = Vasp / Vbpa

        'Map
        Map = Mmp / Sdp ^ 2

        'Catp
        Catp = 1 / (1 / (Vbpa / Box_model.Rho0 / Box_model.Cair ^ 2) + 1 / (Cmp * Sdp ^ 2))

        'Fbtp
        If Derived.enclosure.Box_Type = Box_model.vented_box Then
            Fbtp = Derived.enclosure.Target_Fb
        Else
            Fbtp = 1 / (2 * Math.PI * Math.Sqrt(Map * Catp))
        End If

        'hpa
        hpa = Fbtp / Derived.Fs

        'myp
        myp = Vbpa / (Box_model.Rho0 * Box_model.Cair ^ 2 * Cmp * Sdp ^ 2)

    End Sub

    Public Sub Benson_Coef_calc()
        'Other coefficients are dependent on the first three:

        Dim temp As Double
        'Qaspa
        If Derived.enclosure.Qa < 1 Then temp = 1000000 Else temp = Derived.enclosure.Qa
        Qaspa = temp * hpa

        'Qlspa
        If Derived.enclosure.Ql < 1 Then temp = 1000000 Else temp = Derived.enclosure.Ql
        Qlspa = temp / hpa

        'Qpspa
        If Derived.enclosure.Box_Type = Box_model.vented_box Then
            Qpspa = Qmp
        Else
            Qpspa = 1 / (2 * Math.PI * Derived.Fs * Vbpa / Box_model.Rho0 / Box_model.Cair ^ 2 * Rmp / Sdp ^ 2)
        End If

        Qbspa = 1 / (1 / Qaspa + 1 / Qlspa + 1 / Qpspa)
        Qbsa = 1 / (1 / Qaspa + 1 / Qlspa)

        'coefficients also dependent on these three:
        qpa = 1 / Qaspa + 1 / Qpspa + 1 / (Qaspa * Qlspa * Qpspa)
        qalpa = 1 + 1 / (Qaspa * Qlspa)
        qlppa = 1 + 1 / (Qlspa * Qpspa)

        Dim Qts, Qms As Double
        Qts = Derived.Qts     'local copies to make the equations shorter
        Qms = Derived.Qms

        a0pa = qalpa * (1 + myp)
        a1pa = (1 + myp) * (1 / Qlspa + apa / Qaspa + qalpa / Qts) + hpa ^ 2 * qpa
        a2pa = (1 + myp) * (apa + qalpa + 1 / (Qts * Qlspa)) + myp * hpa ^ 2 * qalpa + hpa ^ 2 * (qlppa + apa / (Qaspa * Qpspa) + qpa / Qts)
        a3pa = myp * (1 / Qlspa + hpa ^ 2 * (apa / Qaspa + qalpa / Qts + 1 / Qlspa)) + hpa ^ 2 * (apa / Qpspa + qlppa / Qts + qpa) + 1 / Qlspa
        a4pa = myp * hpa ^ 2 * (apa + 1 / (Qts * Qlspa) + qalpa) + hpa ^ 2 * qlppa
        a5pa = myp * hpa ^ 2 / Qlspa

        b0pa = 1 + myp
        b1pa = hpa ^ 2 / Qpspa
        b2pa = myp * hpa ^ 2
        d0pa = (1 + myp) * qalpa
        d1pa = (1 + apa) / Qlspa + hpa ^ 2 * qpa
        d2pa = (myp * qalpa + qlppa) * hpa ^ 2
        d3pa = myp * hpa ^ 2 / Qlspa
        e0pa = hpa ^ 2 / Qaspa
        e1pa = hpa ^ 2

        g3pa = Qlspa / hpa ^ 2
        g2pa = Qlspa / Qpspa / (1 + myp)
        g1pa = Qlspa * myp / (1 + myp)
        h3pa = 1 / hpa ^ 2 * (1 / Qaspa + Qlspa)
        h2pa = 1 / hpa ^ 2 + Qlspa / Qaspa / (1 + myp) + 1 / (Qpspa * Qaspa * (1 + myp)) + Qlspa / Qpspa / (1 + myp)
        h1pa = Qlspa / (1 + myp) + 1 / (Qpspa * (1 + myp)) + myp / (1 + myp) * (1 / Qaspa + Qlspa)
        h0pa = myp / (1 + myp)

        a0paz = qalpa * (1 + myp)
        a1paz = (1 + myp) * (1 / Qlspa + apa / Qaspa + qalpa / Qms) + hpa ^ 2 * qpa
        a2paz = (1 + myp) * (apa + qalpa + 1 / (Qms * Qlspa)) + myp * hpa ^ 2 * qalpa + hpa ^ 2 * (qlppa + apa / (Qaspa * Qpspa) + qpa / Qms)
        a3paz = myp * (1 / Qlspa + hpa ^ 2 * (apa / Qaspa + qalpa / Qms + 1 / Qlspa)) + hpa ^ 2 * (apa / Qpspa + qlppa / Qms + qpa) + 1 / Qlspa
        a4paz = myp * hpa ^ 2 * (apa + 1 / (Qms * Qlspa) + qalpa) + hpa ^ 2 * qlppa
        a5paz = myp * hpa ^ 2 / Qlspa

        alpha = Derived.Vas / Derived.Vb * 1000

        If Derived.enclosure.Box_Type = Box_model.PR_box Then
            h = Fbtp / Derived.Fs
        Else
            h = Derived.enclosure.Target_Fb / Derived.Fs
        End If

        beta = Derived.Vas * 1000 / Derived.enclosure.PR.Vas
        a_ab = alpha / (alpha + beta) : b_ab = beta / (alpha + beta)        'a_ab = BensonK9  b_ab = BensonK10
        Qli = 1 / Derived.enclosure.Ql
        Qai = 1 / Derived.enclosure.Qa
        'Qpi = 1 / 1 / Derived.enclosure.PR.Qms
        Qpi = 1 / Qmp
        Q_al = Qli * Qai
        Q_lp = Qli * Qpi
        Q_ap = Qai * Qpi
        Q_lap = Qli * Qai * Qpi

        B5 = 1 + Q_al
        BM5 = B5
        B4 = h * Qpi + 1 / Qts + a_ab * h * Qai + h * Q_lap + h * Qli + Q_al / Qts + alpha / (h * Derived.enclosure.Qa)
        BM4 = h * Qpi + 1 / Qms + a_ab * h * Qai + h * Q_lap + h * Qli + Q_al / Qms + alpha / (h * Derived.enclosure.Qa)
        B3 = b_ab * h ^ 2 + h * Qpi / Qts + 1 + a_ab * h ^ 2 + a_ab * h * Qai / Qts + b_ab * h ^ 2 * Q_al + h ^ 2 * Q_lp + h * Q_lap / Qts + h * Qli / Qts + Q_al + alpha * Q_ap + alpha
        BM3 = b_ab * h ^ 2 + h * Qpi / Qms + 1 + a_ab * h ^ 2 + a_ab * h * Qai / Qms + b_ab * h ^ 2 * Q_al + h ^ 2 * Q_lp + h * Q_lap / Qms + h * Qli / Qms + Q_al + alpha * Q_ap + alpha
        B2 = b_ab * h ^ 2 / Qts + h * Qpi + a_ab * h ^ 2 / Qts + a_ab * h * Qai + b_ab * h ^ 3 * Qli + b_ab * h ^ 2 * Q_al / Qts + h ^ 2 * Q_lp / Qts + h * Q_lap + h * Qli + alpha * b_ab * h * Qai + alpha * h * Qpi
        BM2 = b_ab * h ^ 2 / Qms + h * Qpi + a_ab * h ^ 2 / Qms + a_ab * h * Qai + b_ab * h ^ 3 * Qli + b_ab * h ^ 2 * Q_al / Qms + h ^ 2 * Q_lp / Qms + h * Q_lap + h * Qli + alpha * b_ab * h * Qai + alpha * h * Qpi
        B1 = b_ab * h ^ 2 + a_ab * h ^ 2 + b_ab * h ^ 3 * Qli / Qts + b_ab * h ^ 2 * Q_al + h ^ 2 * Q_lp + alpha * b_ab * h ^ 2
        BM1 = b_ab * h ^ 2 + a_ab * h ^ 2 + b_ab * h ^ 3 * Qli / Qms + b_ab * h ^ 2 * Q_al + h ^ 2 * Q_lp + alpha * b_ab * h ^ 2
        B0 = b_ab * h ^ 3 * Qli
        BM0 = B0

    End Sub

    Public Sub Benson_SPL_calc()
        Dim F, Fn, F2n, F3n, F4n, F5n, Dpa, C1, C2, Omega As Double
        Dim Vc, Sd, Vas, Re, Rs, Qes, Le As Double
        Dim Driver_complex As Complex
        Dim temp As Complex
        Dim VMS As Double = Math.Sqrt(2)
        Dim Gain, Power, Voltage_in, Voltage_required, Applied_voltage, Power_Required, PassRad_Excursion As Double
        Dim Box_and_Vent_Z, Box_Z, Vent_Z, Z_with_Driver, Complex_Voltage, Port_Complex, Denominator As Complex
        Dim Qba, Qloss, Lceb, Lces, Res, Cmep, Cmes As Double

        'Abbreviated variable names
        Re = Derived.Re
        Sd = Derived.Sd
        Vas = Derived.Vas
        Rs = Derived.Rs
        Qes = Derived.Qes
        Le = Derived.Le

        'Pre-calculated values
        C1 = Derived.Cms * Derived.BL * Sd / (Re + Rs)
        C2 = Box_model.Rho0 / P0 * 2 * Math.PI

        'Equivalent Electrical Values
        Lces = Derived.BL ^ 2 * Derived.Cms

        If Derived.enclosure.Box_Type = Box_model.sealed_box Then
            Qba = 1
        Else
            Qba = 1 + 1 / (Math.Sqrt(Derived.enclosure.Qa))
        End If

        Res = (Derived.BL ^ 2 / Derived.Rms) / Qba
        Cmes = Derived.Mms / Derived.BL ^ 2
        Qloss = 10 * Qli
        Lceb = Derived.BL ^ 2 * (Derived.Vb / 1000) / (Box_model.Rho0 * Box_model.Cair ^ 2 * Sd ^ 2)
        Cmep = Box_model.Rho0 * Derived.enclosure.Vent.Lv / 39.37 * Sd ^ 2 / (Derived.BL ^ 2 * Sv)


        Box_model.Max_Gain = Mag(Main.Arrays.Amp_EQ_response.EQ(0))     'Start anywhere, and then check for larger values...
        For n = 1 To Main.Samples - 1
            If Mag(Main.Arrays.Amp_EQ_response.EQ(n)) > Box_model.Max_Gain Then Box_model.Max_Gain = Mag(Main.Arrays.Amp_EQ_response.EQ(n))
        Next
        Box_model.Max_Gain = 20 * Math.Log10(Box_model.Max_Gain)

        Gain = 10 * Math.Log10(Main.BCD.Amp.Woofer_amp.Watts) - Box_model.Max_Gain      'G16
        Derived.Max_output = Derived.SPL1W + Gain           'this added 4/6/2013
        Power = 10 ^ (Gain / 10)       'G17
        Voltage_in = Math.Sqrt(Power * (Re + Rs)) * Math.Sqrt(2)  'G12
        Applied_voltage = (Power * Re) ^ 0.5      'Main C42

        'Mdt = 1/((PI()*2*C5)^2*G6) = G7            G6 = Cms   G8 = BL    Q8 = VC(n)
        Mdt = 1 / ((Math.PI * 2 * Derived.Fs) ^ 2 * Derived.Cms)

        Dim Found_F3 As Boolean = False
        Dim Found_F10 As Boolean = False
        Box_model.Peak_PR_excursion = 0
        Box_model.Peak_Cone_excursion = 0
        Box_model.Peak_velocity = 0
        Box_model.Min_Imp = 100000000           'initialize to high value to find minimum

        For n = 0 To Main.Samples - 1
            F = Main.Frequency(n)
            Omega = F * 2 * Math.PI
            Fn = Main.Frequency(n) / Derived.Fs
            F2n = Fn ^ 2
            F3n = Fn * F2n  'Fn^3
            F4n = Fn * F3n  'Fn^4
            F5n = Fn * F4n  'Fn^5
            Dpa = Math.Sqrt((a5pa - a3pa * F2n + a1pa * F4n) ^ 2 + (a4pa * Fn - a2pa * F3n + a0pa * F5n) ^ 2)  'BU in spreadsheet

            Complex_Voltage = toComplex(Voltage_in, 0) * Main.Arrays.Amp_EQ_response.EQ(n)
            Vc = Mag(Complex_Voltage)
            Power_Required = (Vc / VMS) ^ 2 / (Re + Rs)

            'Total SPL = Mag(Complex Sum * Active Filters) + Max_output
            '=(IMDIV((COMPLEX(b1pa*F4n,b0pa*F5n-b2pa*F3n)),(COMPLEX(a5pa-a3pa*F2n+a1pa*F4n,a4pa*Fn-a2pa*F3n+a0pa*F5n))))
            Main.Arrays.Woofer.Modeled_Response(Box_model.Selected_Driver, n) = toComplex(b1pa * F4n, b0pa * F5n - b2pa * F3n) / toComplex(a5pa - a3pa * F2n + a1pa * F4n, a4pa * Fn - a2pa * F3n + a0pa * F5n)
            Box_model.Total_SPL(Box_model.Selected_Driver, n) = 20 * Math.Log10(Mag(Main.Arrays.Woofer.Modeled_Response(Box_model.Selected_Driver, n) * Main.Arrays.Amp_EQ_response.EQ(n))) + Derived.Max_output

            'Main.Cone_SPL (Cone SPL)
            ' =20*log(derived.Cms*derived.BL*derived.Sd/(derived.Re+derived.Rs)/Dpa(f)
            '  *sqrt((d3pa-d1pa*F2n)^2 + (d2pa*Fn - d0pa*F3n)^2 * (Vc(f)/1.41421)* F^2 * Rho0/P0 *2 * Pi())
            Box_model.Cone_SPL(n) = 20 * Math.Log10(C1 / Dpa * Math.Sqrt((d3pa - d1pa * F2n) ^ 2 + (d2pa * Fn - d0pa * F3n) ^ 2) * (Vc / 1.41421) * Main.Frequency(n) ^ 2 * C2)

            'Main.Vent_SPL (PR SPL)
            '=20*log(MyProject.Woofer.Sd*derived.Cms*derived.BL / (Main.MyProject.Woofer.Re+Main.MyProject.Woofer.Rs)/Dpa(f)
            '  *sqrt((e0pa*F2n)^2+(e1pa*Fn)^2 * (Vc(f)/1.41421)*F^2 * Rho0/P0 *2 * Pi())
            Box_model.Vent_SPL(n) = 20 * Math.Log10(C1 / Dpa * Math.Sqrt((e0pa * F2n) ^ 2 + (e1pa * Fn) ^ 2) * (Vc / 1.41421) * Main.Frequency(n) ^ 2 * C2)

            'Cone Excursion
            '=Cms*BL / (Re+Rs)/Dpa*SQRT((d3pa-d1pa*F2n)^2 + (d2pa*Fn-d0pa*F3n)^2)*Vc*1000
            Box_model.Cone_Excursion(n) = Derived.Cms * Derived.BL / (Re + Rs) / Dpa * Math.Sqrt((d3pa - d1pa * F2n) ^ 2 + (d2pa * Fn - d0pa * F3n) ^ 2) * Vc * 1000
            If Box_model.Cone_Excursion(n) > Box_model.Peak_Cone_excursion Then Box_model.Peak_Cone_excursion = Box_model.Cone_Excursion(n)

            'PR Excursion
            '=Sd/Sdp*Cms*BL/(Re+Rs)/Dpa*SQRT((e0pa*F2n)^2+(e1pa*Fn)^2)*Vc*1000
            Box_model.PR_Excursion(n) = Sd / Sdp * Derived.Cms * Derived.BL / (Re + Rs) / Dpa * Math.Sqrt((e0pa * F2n) ^ 2 + (e1pa * Fn) ^ 2) * Vc * 1000
            If Box_model.PR_Excursion(n) > Box_model.Peak_PR_excursion Then Box_model.Peak_PR_excursion = Box_model.PR_Excursion(n)

            'Port_Complex
            '=COMPLEX($K$9*$K$7*$K$13*AM8^4,-$K$9*$K$7^2*AM8^3)
            Port_Complex = toComplex(a_ab * h * Qai * F4n, -a_ab * h ^ 2 * F3n)                     '=BensonAT  Note:  1/Qb = 1/Qa (Qai)

            'Denominator for Vent Velocity calculation
            '=COMPLEX($K$20*AM8^4-$K$22*AM8^2+$K$24,$K$19*AM8^5+$K$23*AM8-$K$21*AM8^3)
            Denominator = toComplex(B4 * F4n - B2 * F2n + B0, B5 * F5n + B1 * Fn - B3 * F3n)        '=BensonAR

            '$G$5/Benson!$BB$38)*IMABS(IMPRODUCT(COMPLEX(1000*Q8*$G$8/($C$9*$G$7*(2*PI()*$C$5)^2*AM8^2),0),IMDIV(AT8,AR8))
            'Mdt defined outside this loop
            'old:  PassRad_Excursion = Sd / Sdp * Mag(toComplex(1000 * Vc * Derived.BL * Derived.Cms / (Re * F2n), 0) * (Port_Complex / Denominator))  '=BensonAB8, Note:  with Mdt factored out
            PassRad_Excursion = Sd / Sdp * Mag(toComplex(1000 * Vc * Derived.BL / (Re * Mdt * (2 * Math.PI * Derived.Fs) ^ 2 * Fn ^ 2), 0) * (Port_Complex / Denominator))
            'If PassRad_Excursion > Peak_PR_excursion Then Peak_PR_excursion = PassRad_Excursion

            'Vent Velocity 
            'Vms*IMABS(IMPRODUCT(AH8,COMPLEX(Sd/(BL*Sv),0))),0)
            Box_model.Vent_Velocity(n) = PassRad_Excursion * Omega / 1000                           '=BensonAC8, aka PR velocity 
            If Box_model.Vent_Velocity(n) > Box_model.Peak_velocity Then Box_model.Peak_velocity = Box_model.Vent_Velocity(n)


            'Debug code--allows viewing data for any value of "n"
            If n = 499 Then
                n = n
            End If

            'Driver Impedance
            '=COMPLEX(($K$7*$K$14+$K$9*$K$7*$K$13+$K$7*$K$18+$K$7*$K$12)*AM8^4-$K$7^3*($K$10*$K$12)*AM8^2,(1+$K$15)*AM8^5-$K$7^2*($K$10+$K$9+$K$10*$K$15+$K$16)*AM8^3)
            Driver_complex = toComplex((h * Qpi + a_ab * h * Qai + h * Q_lap + h * Qli) * F4n - h ^ 3 * (b_ab * Qli) * F2n, (1 + Q_al) * F5n - h ^ 2 * (b_ab + a_ab + b_ab * Q_al + Q_lp) * F3n)

            'System Impedance
            '=mag(toComplex(0,(2*PI*F(n)*6*Le/1000)^.56) + (toComplex(Re,0) + toComplex(0,-Re/(Qes*Fn) * (Driver_complex / toComplex (BM4*F4n-BM2*F2n+BM0,BM5*F5n+BM1*Fn-Bm3*F3n))
            Box_model.System_Impedance(n) = Mag(toComplex(0, (Omega * 6 * Le / 1000) ^ 0.56) + toComplex(Re, 0) + toComplex(0, -Re / (Qes * Fn)) * (Driver_complex / toComplex(BM4 * F4n - BM2 * F2n + BM0, BM5 * F5n + BM1 * Fn - BM3 * F3n)))
            temp = toComplex(0, (Omega * Le / 1000) ^ 0.56 * 0.4) + toComplex(Re, 0) + toComplex(0, -Re / (Qes * Fn)) * (Driver_complex / toComplex(BM4 * F4n - BM2 * F2n + BM0, BM5 * F5n + BM1 * Fn - BM3 * F3n))
            Box_model.System_Phase(n) = 180 / Math.PI * Math.Atan2(temp.Im, temp.Re)
            If Box_model.System_Impedance(n) < Box_model.Min_Imp Then Box_model.Min_Imp = Box_model.System_Impedance(n)

            'Power Required
            '= (Benson!Q8/1.414)^2/(Re+Main!$C$20)
            Box_model.Amp_Power(n) = (Mag(Main.Arrays.Amp_EQ_response.EQ(n) * toComplex(Voltage_in, 0)) / 1.414) ^ 2 / (Re + Rs)

            'Calculations needed for "Amp into Impedance"
            Box_Z = toComplex(1 / Res, Omega * Cmes - 1 / (Omega * Lces))                           '=V8
            Vent_Z = toComplex(1, 0) / toComplex(Qloss, Omega * Lceb - 1 / (Omega * Cmep))          '=W8
            Box_and_Vent_Z = toComplex(1, 0) / (Box_Z + Vent_Z)                                     '=X8
            Z_with_Driver = toComplex(Re, Omega * Le / 1000) + Box_and_Vent_Z                       '=Y8 

            'Power_Required (CQ8) = IMABS(Q8)^2/Z8
            Voltage_required = Applied_voltage * Mag(Main.Arrays.Amp_EQ_response.EQ(n))
            Box_model.Amp_Into_Impedance(n) = Voltage_required ^ 2 / Mag(Z_with_Driver)
        Next

        'Find F3 and F10

        Box_model.F0 = Box_model.Total_SPL(Box_model.Selected_Driver, Main.Samples - 1)
        For n = 0 To Main.Samples - 1
            F = Main.Frequency(n)

            If Found_F10 = False Then
                If Box_model.Total_SPL(Box_model.Selected_Driver, n) >= Box_model.F0 - 10 Then
                    Box_model.F10 = F
                    Found_F10 = True
                End If
            End If

            If Found_F3 = False Then
                If Box_model.Total_SPL(Box_model.Selected_Driver, n) >= Box_model.F0 - 3 Then
                    Box_model.F3 = F
                    Found_F3 = True
                End If
            End If
            If Found_F10 And Found_F3 Then Exit For
        Next

        Call Box_model.Update_Splice_estimate()

        'Start updating the System Response Window
        If Main.Sys_Response_window_open_flag Then
            Call Main.System_Del.Invoke()
        End If
    End Sub

#End Region

#Region "Controls (Refresh Button)"

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Call Benson_init()
        Call Benson_Coef_calc()
        Call Benson_Load(Nothing, Nothing)
    End Sub

#End Region

End Class