﻿Imports System.IO           'needed for streams
Imports System.Drawing.Drawing2D    'needed for drawing

Public Class Box_model

#Region "Declarations"
    'Constants
    Public Const CR As String = vbCrLf
    Public Const Cair As Double = 345  'Speed of sound
    Public Const Rho0 As Double = 1.18 'Air Density
    Public Const Qtc1 As Double = 0.7071   'Critically damped Q
    Public Const sealed_box As String = "sealed"
    Public Const vented_box As String = "vented"
    Public Const PR_box As String = "PR"
    Public Const bandpass_box As String = "bandpass"

    'Shared Variables
    'Public Shared Steps As Double = 500
    Public Shared Min_Freq As Double = 10
    Public Shared Max_Freq As Double = 1000
    Public Shared sample_rate As Double = 48000
    Public Shared LPF As Boolean
    Public Shared load_flag As Boolean = False
    Public Update_Fb_from_Lv_flag As Boolean = False

    'Units Flags
    Public Vas_Units_Flag As String = "L"
    Public Cabinet_vol_Units_Flag As String = "L"
    'Public Calc_Sealed_vol_Units_Flag As String = "L"
    'Public Vented_vol_Units_Flag As String = "L"
    'Public Calc_Vented_vol_Units_Flag As String = "L"
    Public PR_vol_Units_Flag As String = "L"
    'Public Calc_PR_vol_Units_Flag As String = "L"
    Public SD_Units_Flag As String = "C"
    Public PR_SD_Units_Flag As String = "C"
    Public Diam_Len_Vents_Units_Flag As String = "I"
    Public Len_Vents_Units_Flag As String = "I"
    Public PR_Mms_Units_Flag As String = "G"

    'Flags to manage the chart windows
    Public Derived_param_chart_active As Boolean = False
    Public Referral_flag As Boolean = False
    Public PR_Spec_Window_open_flag As Boolean = False
    'Public SPL_chart_active As Boolean = False
    'Public Excursion_chart_active As Boolean = False
    'Public Imp_Pwr_Chart_active As Boolean = False
    'Public Shared Woofer_box_Tab_item As String

    'Shared Arrays
    'Public Shared Frequency() As Double = New Double(Main.Samples - 1) {}
    Public Shared Coefs() As Double = New Double(7) {}  'coefficient array for texbook filters (gets reused)
    'Public Shared EQ_Responses(,) As Double = New Double(4, Steps - 1) {}   'used to plot data
    Public Shared Filter_Mag() As Double = New Double(Main.Samples - 1) {}     'used to plot data (gets reused)
    Public Shared Filter_Response() As Complex = New Complex(Main.Samples - 1) {}  'temp array for filter response

    Public Shared Total_SPL(,) As Double = New Double(2, Main.Samples - 1) {}
    Public Shared Spliced_SPL(,) As Double = New Double(2, Main.Samples - 1) {}
    Public Shared Cone_SPL() As Double = New Double(Main.Samples - 1) {}
    Public Shared Vent_SPL() As Double = New Double(Main.Samples - 1) {}
    Public Shared Cone_Excursion() As Double = New Double(Main.Samples - 1) {}
    Public Shared PR_Excursion() As Double = New Double(Main.Samples - 1) {}
    Public Shared Vent_Velocity() As Double = New Double(Main.Samples - 1) {}
    Public Shared System_Impedance() As Double = New Double(Main.Samples - 1) {}
    Public Shared System_Phase() As Double = New Double(Main.Samples - 1) {}
    Public Shared Amp_Power() As Double = New Double(Main.Samples - 1) {}
    Public Shared Amp_Into_Impedance() As Double = New Double(Main.Samples - 1) {}
    Public Shared SPL_Compare(,) As Double = New Double(2, Main.Samples - 1) {}
    Public Shared Excursion_Compare(,) As Double = New Double(2, Main.Samples - 1) {}
    Public Shared Power_Compare(,) As Double = New Double(2, Main.Samples - 1) {}

    Public Shared Selected_Driver As Selected_Woofer_box = Selected_Woofer_box.woofer
    Public Enum Selected_Woofer_box
        woofer = 0
        mid1 = 1
        what_if = 2
    End Enum

    'Variables for the delegates
    Delegate Sub Update_Delegate()
    'Public Shared SPL_Del As Update_Delegate
    Public Shared PR_close_del As Update_Delegate
    'Public Shared Excursion_Del As Update_Delegate
    Public Shared Imp_Pwr_Del As Update_Delegate

    'Derived Parameters and internally generated variables
    Public Shared DCR As Double     '= total Driver resistance + series resistance of wiring & crossover
    Public Shared Calc_Sealed_vol As Double
    Public Shared Calc_Vented_vol As Double
    Public Shared Calc_PR_Vol As Double
    Public Shared Calc_Vented_Fb As Double
    Public Shared Mass_to_add As Double
    Public Shared P_diam_min As Double
    Public Shared Sealed_QB As Double
    Public Shared Vented_QB As Double
    Public Shared PR_QB As Double
    Public Shared F3, F10, F0, Min_Imp As Double
    Public Shared Peak_PR_excursion, Peak_Cone_excursion, Peak_velocity As Double

    'Persistent data for the amplifier
    Public Shared P_eff As Double
    Public Shared P_eff_adj As Double           'adjusted by filter response
    Public Shared PR_form As New PR_spec

    'Variables for the Splice Routine
    Public Shared Spliced As Boolean
    Public Shared Splice_point As Integer
    Public Splice_freq As Double
    Public Splice_freq_index As Integer = 80
    Public Shared Splice_offset As Double
    Public Shared mouse_over_splice_box As Boolean
    Public Shared mouse_over_woofer_ampl As Boolean
    Public Shared mouse_over_Mid1_ampl As Boolean
    Public Shared Vert_scalefactor, Horiz_scalefactor As Double
    Public Shared Driver1_calculated_offset As Double = 0
    Public Shared Driver2_calculated_offset As Double = 0
    Const max_height_of_graph = 20
    Dim splice_freq_values() As Double = New Double(28) {100, 110, 120, 130, 150, 160, 180, 200, 220, 240, 270, 300, 330, 360, 390, 430, 470, 510, 560, 620, 680, 750, 820, 910, 1000, 1200, 1500, 1800, 2200}
    Dim splice_offset_values() As Double = New Double(30) {-12, -11, -10, -9, -8, -7, -6, -5, -4, -3, -2.5, -2, -1.5, -1, -0.5, 0, 0.5, 1, 1.5, 2, 2.5, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12}

    'Variables for Paint routines
    Dim myFont As New Font("Arial", 8)
    Dim myBrush As New SolidBrush(Color.DarkRed)
    Dim Splice_box_left, Splice_box_right As Integer
    Dim P1, P2 As Point
    Dim pen As Pen
    Dim Splice_box_normal_pen As New Pen(Color.ForestGreen, 1)
    Dim Splice_box_highlight_pen As New Pen(Color.Chartreuse, 2)
    Dim Woofer_SPL_normal_pen As New Pen(Color.IndianRed, 1)
    Dim Woofer_SPL_highlight_pen As New Pen(Color.HotPink, 2)
    Dim SPL_max As Double = 0
    Dim SPL_min As Double = 10000

    Public Shared Box_Volume_values(40) As Double
    Public Shared Vent_diameter_values(40) As Double
    Const Vol_scale As Double = 2    'Range of cabinet volume values
    Public Shared Max_Gain As Double 'make visible to both Derived and Benson

    Public max_value, max1db, min1db, max2db, min2db, max3db, min3db As Double
    Dim memoryImage As Bitmap   'used for printing
    Public Shared Design_Number As Integer = 1
    Public Shared Design_1_enabled As Boolean = False
    Public Shared Design_2_enabled As Boolean = False
    Public Shared Design_3_enabled As Boolean = False
    Public Shared Update_Comparison_window As Update_Delegate

#End Region

#Region "Window Load, Resize and Close"

    'Initialization code executed when the main window is loaded
    Public Sub Woofer_box_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Color_Chooser.Color_set(Me)
        Dim toolTip1 As New ToolTip()

        ' Set up the ToolTip text for the Pictures and the Start Button
        toolTip1.SetToolTip(Me.What_if_EBP_TextBox, "Efficiency Bandwidth Product = Fs/Qe")
        toolTip1.SetToolTip(Me.What_if_EBP_TrackBar, "'Rule of Thumb' guidance only")
        'toolTip1.SetToolTip(Me.Button1, "Start the design")

        'initialize the driver and box configurations
        Call Box_Type_Tab_Click(Nothing, Nothing)

        'Dim SPL_window As New SPL_calc
        'SPL_Del = AddressOf SPL_window.Update_SPL
        'SPL_window.Show()

        Call array_init()
        Call Units_init()
        Call Main_Form_Init()       'Load up the form boxes with the data from the Project Object
        Call PR_Form_Init()         'Load up the PR boxes with the default data
        Call Tab_Form_Init()        'load up the Tabbed data
        Call Scale_init()
        Call SPL_chart_init()
        Call Excursion_chart_init()
        Call Impedance_chart_init()
        Call Power_Chart_init()

        Call Config_Driver_1_Click(Nothing, Nothing)            'calls Derived.Calc_derived()
        Call Update_Calculated_Values()
        Call Update_Splice_estimate()
        Call Color_Read_Only()

        PR_close_del = AddressOf PR_spec.Close_me
    End Sub

    Public Sub Woofer_Box_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        'No code required--Docking takes care of this
    End Sub

    Public Sub Woofer_Box_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.FormClosed
        Main.Woofer_box_window_open_flag = False
    End Sub

#End Region

#Region "Initialization"

    Sub Main_Form_Init()

        'Woofer Tab
        Woofer_name_label.Text = Main.BCD.Spkr.driver1.driver_name
        Woofer_Fs_label.Text = "Fs: " & Str(Main.BCD.Spkr.driver1.TS_Parameters.Fs)
        Woofer_Qts_label.Text = "Qts: " & Str(Main.BCD.Spkr.driver1.TS_Parameters.Qts)
        Woofer_Vas_label.Text = "Vas: " & Units.Liters_to_units(Main.BCD.Spkr.driver1.TS_Parameters.Vas, Vas_Units_Flag)
        Woofer_Re_label.Text = "Re: " & Str(Main.BCD.Spkr.driver1.TS_Parameters.Re)
        Woofer_Sd_label.Text = "Sd: " & Units.SD_to_units(Main.BCD.Spkr.driver1.TS_Parameters.Sd, SD_Units_Flag)
        'Le_TextBox.Text = Main.BCD.Spkr.driver1.TS_Parameters.Le
        Woofer_Xmax_label.Text = "Xmax: " & Str(Main.BCD.Spkr.driver1.TS_Parameters.Xmax)
        Woofer_Splice_CheckBox.Checked = Main.BCD.Spkr.driver1.TS_Parameters.Spliced
        Woofer_splice_freq_textbox.Text = Str(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Freq)
        Woofer_splice_offset_textbox.Text = Str(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_added)

        'Mid1 Tab
        Mid1_name_label.Text = Main.BCD.Spkr.driver2.driver_name
        Mid1_Fs_label.Text = "Fs: " & Str(Main.BCD.Spkr.driver2.TS_Parameters.Fs)
        Mid1_Qts_label.Text = "Qts: " & Str(Main.BCD.Spkr.driver2.TS_Parameters.Qts)
        Mid1_Vas_label.Text = "Vas: " & Units.Liters_to_units(Main.BCD.Spkr.driver2.TS_Parameters.Vas, Vas_Units_Flag)
        Mid1_Re_label.Text = "Re: " & Str(Main.BCD.Spkr.driver2.TS_Parameters.Re)
        Mid1_Sd_label.Text = "Sd: " & Units.SD_to_units(Main.BCD.Spkr.driver2.TS_Parameters.Sd, SD_Units_Flag)
        Mid1_Xmax_label.Text = "Xmax: " & Str(Main.BCD.Spkr.driver2.TS_Parameters.Xmax)
        Mid1_Splice_CheckBox.Checked = Main.BCD.Spkr.driver2.TS_Parameters.Spliced
        Mid1_splice_freq_textbox.Text = Str(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Freq)
        Mid1_splice_offset_textbox.Text = Str(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Offset_added)

        'What_if Tab
        What_if_Name_TextBox.Text = Main.BCD.Cabinet.Woofer.Name
        What_if_Fs_TextBox.Text = Main.BCD.Cabinet.Woofer.Fs
        What_if_Qts_TextBox.Text = Main.BCD.Cabinet.Woofer.Qts
        What_if_Vas_TextBox.Text = Main.BCD.Cabinet.Woofer.Vas
        What_if_Re_TextBox.Text = Main.BCD.Cabinet.Woofer.Re
        What_if_Sd_TextBox.Text = Main.BCD.Cabinet.Woofer.Sd
        What_if_Xmax_TextBox.Text = Main.BCD.Cabinet.Woofer.Xmax


        Call EBP_TrackBar_Scroll(Nothing, Nothing)
        'Call EQ_init()
        load_flag = True    'done loading

        Selected_Driver = Selected_Woofer_box.mid1
        Mid1_Splicebox.Refresh()
        Selected_Driver = Selected_Woofer_box.woofer
        Woofer_Splicebox.Refresh()

        If Main.BCD.Project.Program_name = Program_type.PSD_Lite Then
            ' Driver_database_button.Hide()
        End If

    End Sub

    Sub PR_Form_Init()

        'The PR form is shared between Woofer, Midrange and "What-if"
        Dim enclosure As New Box_spec
        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                enclosure = Main.BCD.Spkr.driver1.Enclosure
            Case Selected_Woofer_box.mid1
                enclosure = Main.BCD.Spkr.driver2.Enclosure
            Case Selected_Woofer_box.what_if
                enclosure = Main.BCD.Cabinet.Box
        End Select

        PR_form.Name_TextBox.Text = enclosure.PR.Name
        PR_form.Fs_TextBox.Text = Str(enclosure.PR.Fs)
        PR_form.PR_Vas_TextBox.Text = Str(enclosure.PR.Vas)
        PR_form.Rms_TextBox.Text = Str(enclosure.PR.Rms)
        PR_form.PR_Sd_TextBox.Text = Str(enclosure.PR.Sd)
        PR_form.Mms_TextBox.Text = Str(enclosure.PR.Mms)
        PR_form.Cms_TextBox.Text = Str(enclosure.PR.Cms)
        PR_form.Qms_TextBox.Text = Str(enclosure.PR.Qms)
        PR_form.Mms_TextBox.Text = Str(enclosure.PR.Mms)
        PR_form.Xmax_TextBox.Text = Str(enclosure.PR.Xmax)

    End Sub

    Sub Tab_Form_Init()

        'set up the tabs:  first remove them and then add back in if the driver is enabled
        Woofer_Tab_Control.TabPages.Remove(What_if_Box_Tab)
        Woofer_Tab_Control.TabPages.Remove(Mid1_Box_Tab)

        'Tabs all removed:  now add them back in if the driver is enabled

        If Main.BCD.Spkr.Configuration = Sys_config_type.Sys_2_full_sub Or
           Main.BCD.Spkr.Configuration = Sys_config_type.Sys_2_way_2_sub Or
           Main.BCD.Spkr.Configuration = Sys_config_type.Sys_3_way Or
           Main.BCD.Spkr.Configuration = Sys_config_type.Sys_3_way_2 Or
           Main.BCD.Spkr.Configuration = Sys_config_type.Sys_3_way_2_sub Or
           Main.BCD.Spkr.Configuration = Sys_config_type.Sys_4_full Or
           Main.BCD.Spkr.Configuration = Sys_config_type.Sys_4_way Or
           Main.BCD.Spkr.Configuration = Sys_config_type.Sys_4_way_2 Or
           Main.BCD.Spkr.Configuration = Sys_config_type.Sys_5_1 Or
           Main.BCD.Spkr.Configuration = Sys_config_type.Sys_6_way Or
           Main.BCD.Spkr.Configuration = Sys_config_type.Sys_7_1 Then
            Woofer_Tab_Control.TabPages.Add(Mid1_Box_Tab)

        End If
        Woofer_Tab_Control.TabPages.Add(What_if_Box_Tab)
        Woofer_Tab_Control.SelectedIndex = 0
        Selected_Driver = Selected_Woofer_box.woofer


        Dim enclosure As New Box_spec
        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                enclosure = Main.BCD.Spkr.driver1.Enclosure
            Case Selected_Woofer_box.mid1
                enclosure = Main.BCD.Spkr.driver2.Enclosure
            Case Selected_Woofer_box.what_if
                enclosure = Main.BCD.Cabinet.Box
        End Select

        Sealed_Vol_TextBox.Text = Units.Liters_to_units(enclosure.Volume_sealed, Cabinet_vol_Units_Flag)
        Call Qb_edit.Update_Qb()
        'Sealed_QB_TextBox.Text = Str(Main.BCD.Cabinet.Box.Qa)
        'need to calculate QB
        Vented_Vol_TextBox.Text = Units.Liters_to_units(enclosure.Volume_vented, Cabinet_vol_Units_Flag)
        Vented_Fb_TextBox.Text = Str(enclosure.Target_Fb)
        Qty_Vents_TextBox.Text = Str(enclosure.Vent.Nv)
        Diameter_Vents_TextBox.Text = Units.Len_to_units(enclosure.Vent.Dv, Diam_Len_Vents_Units_Flag)
        PR_Vol_TextBox.Text = Str(enclosure.Volume_PR)
        PR_Fb_TextBox.Text = Str(enclosure.Target_Fb)
        PR_Qty_TextBox.Text = Str(enclosure.PR.Np)
        PR_AddedMass_TextBox.Text = Str(enclosure.PR.Mass_added)
    End Sub

    Sub Update_Calculated_Values()
        'Must call derived.Calc_derived() before updating these textboxes
        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                Calc_Vent_Len_TextBox.Text = Units.Len_to_units(Main.BCD.Spkr.driver1.Enclosure.Vent.Lv, Diam_Len_Vents_Units_Flag)
            Case Selected_Woofer_box.mid1
                Calc_Vent_Len_TextBox.Text = Units.Len_to_units(Main.BCD.Spkr.driver2.Enclosure.Vent.Lv, Diam_Len_Vents_Units_Flag)
            Case Selected_Woofer_box.what_if
                Calc_Vent_Len_TextBox.Text = Units.Len_to_units(Main.BCD.Cabinet.Box.Vent.Lv, Diam_Len_Vents_Units_Flag)
        End Select

        Sealed_QB_TextBox.Text = Str(Math.Round(Sealed_QB, 0))
        Vented_QB_TextBox.Text = Str(Math.Round(Vented_QB, 0))
        PR_QB_TextBox.Text = Str(Math.Round(Vented_QB, 0))

    End Sub

    Sub array_init()

        'Initialize chart data
        For j = 0 To 2
            For n = 0 To Main.Samples - 1
                Woofer_SPL_Chart.Series(j).Points.AddXY(Main.Frequency(n), 0)
                Spliced_SPL(j, n) = 90
                Total_SPL(j, n) = 90
            Next n
        Next j
        For j = 0 To 4
            For n = 0 To Main.Samples - 1
                Excursion_Chart.Series(j).Points.AddXY(Main.Frequency(n), 0)
            Next n
        Next j
        For j = 0 To 1
            For n = 0 To Main.Samples - 1
                Woofer_Impedance_Chart.Series(j).Points.AddXY(Main.Frequency(n), 0)
            Next n
        Next j
        For j = 0 To 1
            For n = 0 To Main.Samples - 1
                Power_Chart.Series(j).Points.AddXY(Main.Frequency(n), 0)
            Next n
        Next j

        For j = 0 To 2
            For n = 0 To Main.Samples - 1
                SPL_Compare(j, n) = 90
                Excursion_Compare(j, n) = 5
                Power_Compare(j, n) = 100
            Next n
        Next j

    End Sub

    Sub Scale_init()
        SPL_ScaleButton2.Checked = False
        SPL_ScaleButton1.Checked = True
        SPL_ScaleButton0.Checked = False

        Impedance_ScaleButton2.Checked = True
        Impedance_ScaleButton1.Checked = False
        Impedance_ScaleButton0.Checked = False

    End Sub

    Sub Color_Read_Only()
        Sealed_QB_TextBox.BackColor = SystemColors.Control
        PR_QB_TextBox.BackColor = SystemColors.Control
        Vented_QB_TextBox.BackColor = SystemColors.Control
        Calc_Vent_Len_TextBox.BackColor = SystemColors.Control

    End Sub

    Sub Units_init()
        Select Case Main.BCD.Project.Units_default

            Case "D"        'default mix of english (length) and metric (volume)
                Vas_Units_Flag = "L"
                Cabinet_vol_Units_Flag = "L"
                SD_Units_Flag = "C"
                PR_SD_Units_Flag = "C"
                Diam_Len_Vents_Units_Flag = "I"
                PR_Mms_Units_Flag = "G"

            Case "E"        'English units
                Vas_Units_Flag = "F"
                Cabinet_vol_Units_Flag = "F"
                SD_Units_Flag = "I"
                PR_SD_Units_Flag = "I"
                Diam_Len_Vents_Units_Flag = "I"
                PR_Mms_Units_Flag = "G"         'weight not supported yet

            Case "M"        'Metric units
                Vas_Units_Flag = "L"
                Cabinet_vol_Units_Flag = "L"

                SD_Units_Flag = "C"
                PR_SD_Units_Flag = "C"
                Diam_Len_Vents_Units_Flag = "M"
                PR_Mms_Units_Flag = "G"

        End Select

        Sealed_Vol_units_Button.Text = Units.Liters_conv_text(Cabinet_vol_Units_Flag)   'figure out button text
        Vented_Vol_units_button.Text = Units.Liters_conv_text(Cabinet_vol_Units_Flag)
        PR_Volume_Units_Button.Text = Units.Liters_conv_text(Cabinet_vol_Units_Flag)
        Diam_Vents_Units_Button.Text = Units.Len_conv_text(Diam_Len_Vents_Units_Flag)
        Len_Vents_Units_Button.Text = Units.Len_conv_text(Diam_Len_Vents_Units_Flag)
        What_if_Vas_units_Button.Text = Units.Liters_conv_text(Vas_Units_Flag)
        What_if_Sd_units_Button.Text = Units.SD_conv_text(SD_Units_Flag)

    End Sub

#End Region

#Region "Configuration Menu Items"
    Private Sub Config_Driver_1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Config_Driver_1.Click

        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                'Update the configuration number
                Main.BCD.Spkr.driver1.TS_Parameters.Driver_Config = 0
                'Update the configuration 
                Main.BCD.Spkr.driver1.TS_Parameters.Config.ReX = 1 : Main.BCD.Spkr.driver1.TS_Parameters.Config.SdX = 1 : Main.BCD.Spkr.driver1.TS_Parameters.Config.VasX = 1 : Main.BCD.Spkr.driver1.TS_Parameters.Config.nD = 1
            Case Selected_Woofer_box.mid1
                Main.BCD.Spkr.driver2.TS_Parameters.Driver_Config = 0
                Main.BCD.Spkr.driver2.TS_Parameters.Config.ReX = 1 : Main.BCD.Spkr.driver2.TS_Parameters.Config.SdX = 1 : Main.BCD.Spkr.driver2.TS_Parameters.Config.VasX = 1 : Main.BCD.Spkr.driver2.TS_Parameters.Config.nD = 1
            Case Selected_Woofer_box.what_if
                Main.BCD.Cabinet.Woofer.Driver_Config = 0
                Main.BCD.Cabinet.Woofer.Config.ReX = 1 : Main.BCD.Cabinet.Woofer.Config.SdX = 1 : Main.BCD.Cabinet.Woofer.Config.VasX = 1 : Main.BCD.Cabinet.Woofer.Config.nD = 1
        End Select

        Config_image.Image = My.Resources.D1
        Call Box_Type_Tab_Click(Nothing, Nothing)
        Call Derived.Calc_derived()
    End Sub

    Private Sub Config_2_Parallel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Config_2_Parallel.Click

        Select Case Selected_Driver
            Case 0
                'Update the configuration number
                Main.BCD.Spkr.driver1.TS_Parameters.Driver_Config = 1
                'Update the configuration 
                Main.BCD.Spkr.driver1.TS_Parameters.Config.ReX = 0.5 : Main.BCD.Spkr.driver1.TS_Parameters.Config.SdX = 2 : Main.BCD.Spkr.driver1.TS_Parameters.Config.VasX = 2 : Main.BCD.Spkr.driver1.TS_Parameters.Config.nD = 2
            Case 1
                Main.BCD.Spkr.driver2.TS_Parameters.Driver_Config = 1
                Main.BCD.Spkr.driver2.TS_Parameters.Config.ReX = 0.5 : Main.BCD.Spkr.driver2.TS_Parameters.Config.SdX = 2 : Main.BCD.Spkr.driver2.TS_Parameters.Config.VasX = 2 : Main.BCD.Spkr.driver2.TS_Parameters.Config.nD = 2
            Case 2
                Main.BCD.Cabinet.Woofer.Driver_Config = 1
                Main.BCD.Cabinet.Woofer.Config.ReX = 0.5 : Main.BCD.Cabinet.Woofer.Config.SdX = 2 : Main.BCD.Cabinet.Woofer.Config.VasX = 2 : Main.BCD.Cabinet.Woofer.Config.nD = 2
        End Select

        Config_image.Image = My.Resources.D2P
        Call Box_Type_Tab_Click(Nothing, Nothing)
        Call Derived.Calc_derived()
    End Sub

    Private Sub Config_2_Series_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Config_2_Series.Click

        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                'Update the configuration number
                Main.BCD.Spkr.driver1.TS_Parameters.Driver_Config = 2
                'Update the configuration 
                Main.BCD.Spkr.driver1.TS_Parameters.Config.ReX = 2 : Main.BCD.Spkr.driver1.TS_Parameters.Config.SdX = 2 : Main.BCD.Spkr.driver1.TS_Parameters.Config.VasX = 2 : Main.BCD.Spkr.driver1.TS_Parameters.Config.nD = 2
            Case Selected_Woofer_box.mid1
                Main.BCD.Spkr.driver2.TS_Parameters.Driver_Config = 2
                Main.BCD.Spkr.driver2.TS_Parameters.Config.ReX = 2 : Main.BCD.Spkr.driver2.TS_Parameters.Config.SdX = 2 : Main.BCD.Spkr.driver2.TS_Parameters.Config.VasX = 2 : Main.BCD.Spkr.driver2.TS_Parameters.Config.nD = 2
            Case Selected_Woofer_box.what_if
                Main.BCD.Cabinet.Woofer.Driver_Config = 2
                Main.BCD.Cabinet.Woofer.Config.ReX = 2 : Main.BCD.Cabinet.Woofer.Config.SdX = 2 : Main.BCD.Cabinet.Woofer.Config.VasX = 2 : Main.BCD.Cabinet.Woofer.Config.nD = 2
        End Select

        Config_image.Image = My.Resources.D2S
        Call Derived.Calc_derived()
        Call Box_Type_Tab_Click(Nothing, Nothing)
    End Sub

    Private Sub Config_3_Parallel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Config_3_Parallel.Click

        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                'Update the configuration number
                Main.BCD.Spkr.driver1.TS_Parameters.Driver_Config = 3
                'Update the configuration 
                Main.BCD.Spkr.driver1.TS_Parameters.Config.ReX = 0.333 : Main.BCD.Spkr.driver1.TS_Parameters.Config.SdX = 3 : Main.BCD.Spkr.driver1.TS_Parameters.Config.VasX = 3 : Main.BCD.Spkr.driver1.TS_Parameters.Config.nD = 3
            Case Selected_Woofer_box.mid1
                Main.BCD.Spkr.driver2.TS_Parameters.Driver_Config = 3
                Main.BCD.Spkr.driver2.TS_Parameters.Config.ReX = 0.333 : Main.BCD.Spkr.driver2.TS_Parameters.Config.SdX = 3 : Main.BCD.Spkr.driver2.TS_Parameters.Config.VasX = 3 : Main.BCD.Spkr.driver2.TS_Parameters.Config.nD = 3
            Case Selected_Woofer_box.what_if
                Main.BCD.Cabinet.Woofer.Driver_Config = 3
                Main.BCD.Cabinet.Woofer.Config.ReX = 0.333 : Main.BCD.Cabinet.Woofer.Config.SdX = 3 : Main.BCD.Cabinet.Woofer.Config.VasX = 3 : Main.BCD.Cabinet.Woofer.Config.nD = 3
        End Select

        Config_image.Image = My.Resources.D3P
        Call Derived.Calc_derived()
        Call Box_Type_Tab_Click(Nothing, Nothing)
    End Sub

    Private Sub Config_3_Series_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Config_3_Series.Click

        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                'Update the configuration number
                Main.BCD.Spkr.driver1.TS_Parameters.Driver_Config = 4
                'Update the configuration 
                Main.BCD.Spkr.driver1.TS_Parameters.Config.ReX = 3 : Main.BCD.Spkr.driver1.TS_Parameters.Config.SdX = 3 : Main.BCD.Spkr.driver1.TS_Parameters.Config.VasX = 3 : Main.BCD.Spkr.driver1.TS_Parameters.Config.nD = 3
            Case Selected_Woofer_box.mid1
                Main.BCD.Spkr.driver2.TS_Parameters.Driver_Config = 4
                Main.BCD.Spkr.driver2.TS_Parameters.Config.ReX = 3 : Main.BCD.Spkr.driver2.TS_Parameters.Config.SdX = 3 : Main.BCD.Spkr.driver2.TS_Parameters.Config.VasX = 3 : Main.BCD.Spkr.driver2.TS_Parameters.Config.nD = 3
            Case Selected_Woofer_box.what_if
                Main.BCD.Cabinet.Woofer.Driver_Config = 4
                Main.BCD.Cabinet.Woofer.Config.ReX = 3 : Main.BCD.Cabinet.Woofer.Config.SdX = 3 : Main.BCD.Cabinet.Woofer.Config.VasX = 3 : Main.BCD.Cabinet.Woofer.Config.nD = 3
        End Select

        Config_image.Image = My.Resources.D3S
        Call Derived.Calc_derived()
        Call Box_Type_Tab_Click(Nothing, Nothing)
    End Sub

    Private Sub Config_4_Series_Parallel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Config_4_Series_Parallel.Click

        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                'Update the configuration number
                Main.BCD.Spkr.driver1.TS_Parameters.Driver_Config = 5
                'Update the configuration 
                Main.BCD.Spkr.driver1.TS_Parameters.Config.ReX = 1 : Main.BCD.Spkr.driver1.TS_Parameters.Config.SdX = 4 : Main.BCD.Spkr.driver1.TS_Parameters.Config.VasX = 4 : Main.BCD.Spkr.driver1.TS_Parameters.Config.nD = 4
            Case Selected_Woofer_box.mid1
                Main.BCD.Spkr.driver2.TS_Parameters.Driver_Config = 5
                Main.BCD.Spkr.driver2.TS_Parameters.Config.ReX = 1 : Main.BCD.Spkr.driver2.TS_Parameters.Config.SdX = 4 : Main.BCD.Spkr.driver2.TS_Parameters.Config.VasX = 4 : Main.BCD.Spkr.driver2.TS_Parameters.Config.nD = 4
            Case Selected_Woofer_box.what_if
                Main.BCD.Cabinet.Woofer.Driver_Config = 5
                Main.BCD.Cabinet.Woofer.Config.ReX = 1 : Main.BCD.Cabinet.Woofer.Config.SdX = 4 : Main.BCD.Cabinet.Woofer.Config.VasX = 4 : Main.BCD.Cabinet.Woofer.Config.nD = 4
        End Select

        Config_image.Image = My.Resources.D4S_P
        Call Derived.Calc_derived()
        Call Box_Type_Tab_Click(Nothing, Nothing)
    End Sub

    Private Sub Config_2_compound_in_Parallel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Config_2_compound_in_Parallel.Click

        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                'Update the configuration number
                Main.BCD.Spkr.driver1.TS_Parameters.Driver_Config = 6
                'Update the configuration 
                Main.BCD.Spkr.driver1.TS_Parameters.Config.ReX = 0.5 : Main.BCD.Spkr.driver1.TS_Parameters.Config.SdX = 1 : Main.BCD.Spkr.driver1.TS_Parameters.Config.VasX = 0.5 : Main.BCD.Spkr.driver1.TS_Parameters.Config.nD = 2
            Case Selected_Woofer_box.mid1
                Main.BCD.Spkr.driver2.TS_Parameters.Driver_Config = 6
                Main.BCD.Spkr.driver2.TS_Parameters.Config.ReX = 0.5 : Main.BCD.Spkr.driver2.TS_Parameters.Config.SdX = 1 : Main.BCD.Spkr.driver2.TS_Parameters.Config.VasX = 0.5 : Main.BCD.Spkr.driver2.TS_Parameters.Config.nD = 2
            Case Selected_Woofer_box.what_if
                Main.BCD.Cabinet.Woofer.Driver_Config = 6
                Main.BCD.Cabinet.Woofer.Config.ReX = 0.5 : Main.BCD.Cabinet.Woofer.Config.SdX = 1 : Main.BCD.Cabinet.Woofer.Config.VasX = 0.5 : Main.BCD.Cabinet.Woofer.Config.nD = 2
        End Select

        Config_image.Image = My.Resources.C2_P
        Call Derived.Calc_derived()
        Call Box_Type_Tab_Click(Nothing, Nothing)
    End Sub

    Private Sub Config_2_compound_in_Series_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Config_2_compound_in_Series.Click

        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                'Update the configuration number
                Main.BCD.Spkr.driver1.TS_Parameters.Driver_Config = 7
                'Update the configuration 
                Main.BCD.Spkr.driver1.TS_Parameters.Config.ReX = 2 : Main.BCD.Spkr.driver1.TS_Parameters.Config.SdX = 1 : Main.BCD.Spkr.driver1.TS_Parameters.Config.VasX = 0.5 : Main.BCD.Spkr.driver1.TS_Parameters.Config.nD = 2
            Case Selected_Woofer_box.mid1
                Main.BCD.Spkr.driver2.TS_Parameters.Driver_Config = 7
                Main.BCD.Spkr.driver2.TS_Parameters.Config.ReX = 2 : Main.BCD.Spkr.driver2.TS_Parameters.Config.SdX = 1 : Main.BCD.Spkr.driver2.TS_Parameters.Config.VasX = 0.5 : Main.BCD.Spkr.driver2.TS_Parameters.Config.nD = 2
            Case Selected_Woofer_box.what_if
                Main.BCD.Cabinet.Woofer.Driver_Config = 7
                Main.BCD.Cabinet.Woofer.Config.ReX = 2 : Main.BCD.Cabinet.Woofer.Config.SdX = 1 : Main.BCD.Cabinet.Woofer.Config.VasX = 0.5 : Main.BCD.Cabinet.Woofer.Config.nD = 2
        End Select

        Config_image.Image = My.Resources.C2_S
        Call Derived.Calc_derived()
        Call Box_Type_Tab_Click(Nothing, Nothing)
    End Sub

    Private Sub Enclosure_image_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Enclosure_image.Click
        Select Case Box_type_TabControl.SelectedIndex
            Case 0
                Box_type_TabControl.SelectedIndex = 1
            Case 1
                Box_type_TabControl.SelectedIndex = 2
            Case 2
                Box_type_TabControl.SelectedIndex = 0
        End Select
    End Sub

    Private Sub Config_image_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Config_image.Click
        Dim config_item As Integer
        config_item = Get_Driver_Config(Selected_Driver)
        config_item = config_item + 1
        If config_item > Configuration_MenuItem.DropDownItems.Count - 1 Then config_item = 0
        Call Update_Driver_Config(config_item)
    End Sub

    Function Get_Driver_Config(ByVal index)
        Select Case index
            Case 0
                'retrieve the configuration
                Get_Driver_Config = Main.BCD.Spkr.driver1.TS_Parameters.Driver_Config
            Case 1
                Get_Driver_Config = Main.BCD.Spkr.driver2.TS_Parameters.Driver_Config
            Case Else
                Get_Driver_Config = Main.BCD.Cabinet.Woofer.Driver_Config
        End Select
    End Function

    Sub Update_Driver_Config(ByVal config_item)
        'update the configuration
        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                'retrieve the configuration
                Main.BCD.Spkr.driver1.TS_Parameters.Driver_Config = config_item
            Case Selected_Woofer_box.mid1
                Main.BCD.Spkr.driver2.TS_Parameters.Driver_Config = config_item
            Case Selected_Woofer_box.what_if
                Main.BCD.Cabinet.Woofer.Driver_Config = config_item
        End Select

        Configuration_MenuItem.DropDownItems.Item(config_item).PerformClick()

    End Sub

#End Region

#Region "Menu Items -- Options and Help"

    Private Sub DerivedParametersToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DerivedParametersToolStripMenuItem.Click
        Dim Param_window As New Derived
        Param_window.Show()
        'Derived parameters copied to text boxes for display in the Derived.vb module
    End Sub

    Private Sub UserManualBoxModelerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UserManualBoxModelerToolStripMenuItem.Click
        Dim Modeler_help As New Web_browser
        Modeler_help.Show()
        Modeler_help.WebBrowser1.Navigate("http://www.audiodevelopers.com/Software/Online_help/Shared/Woofer_box.htm")
    End Sub

    Private Sub Design1_MenuItem_Click(sender As Object, e As EventArgs) Handles Design1_MenuItem.Click
        Design_Number = 0
        Design_1_enabled = True
        Call Compare()
    End Sub

    Private Sub Design2_MenuItem_Click(sender As Object, e As EventArgs) Handles Design2_MenuItem.Click
        Design_Number = 1
        Design_2_enabled = True
        Call Compare()
    End Sub

    Private Sub Design3_MenuItem_Click(sender As Object, e As EventArgs) Handles Design3_MenuItem.Click
        Design_Number = 2
        Design_3_enabled = True
        Call Compare()
    End Sub

#End Region

#Region "Compare Window"
    Sub Compare()
        If Main.Compare_window_open_flag = False Then
            Dim Compare_all As New Compare_Window
            Update_Comparison_window = AddressOf Compare_all.Update_Comparison_delegate
            Compare_all.Show()
        End If

        For n = 0 To Main.Samples - 1
            For i = 0 To 2
                SPL_Compare(Design_Number, n) = Total_SPL(Selected_Driver, n)
                Excursion_Compare(Design_Number, n) = Cone_Excursion(n)
                Power_Compare(Design_Number, n) = Amp_Power(n)
            Next i
        Next n

        Update_Comparison_window.Invoke()

    End Sub

#End Region

#Region "Invocations using delegates"
    'This routine allows subordinate windows to update the SPL graph (uses a delegate)

    Sub Update_WooferBox_Charts()
        Call Update_SPL_chart()
        Call Update_Excursion_chart()
        Call Update_Impedance_chart()
        Call Update_Power_chart()
    End Sub

    Sub Close_PR_data()
        Box_model.PR_close_del.Invoke()
        Call Update_Calculated_Values()
    End Sub

    Sub Update_Benson_delegated()
        Call Main_Form_Init()
        Call PR_Form_Init()
        If PR_Spec_Window_open_flag Then

        End If
        Call Derived.Update_Benson()
        Call Update_Calculated_Values()
    End Sub

    Sub Update_derived_delegate()
        Call Derived.Calc_derived() 'update the derived parameters if user changes the value
        Call Update_Calculated_Values()       'Update the derived text boxes
        'What_if Tab
        What_if_Name_TextBox.Text = Main.BCD.Cabinet.Woofer.Name
        What_if_Fs_TextBox.Text = Main.BCD.Cabinet.Woofer.Fs
        What_if_Qts_TextBox.Text = Main.BCD.Cabinet.Woofer.Qts
        What_if_Vas_TextBox.Text = Main.BCD.Cabinet.Woofer.Vas
        What_if_Re_TextBox.Text = Main.BCD.Cabinet.Woofer.Re
        What_if_Sd_TextBox.Text = Main.BCD.Cabinet.Woofer.Sd
        What_if_Xmax_TextBox.Text = Main.BCD.Cabinet.Woofer.Xmax
    End Sub

#End Region

#Region "Driver Data Text Boxes"

    Private Sub Name_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles What_if_Name_TextBox.TextChanged
        If What_if_Name_TextBox.Focused Then
            Main.BCD.Cabinet.Woofer.Name = What_if_Name_TextBox.Text
        End If
    End Sub

    Private Sub Fs_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles What_if_Fs_TextBox.TextChanged
        If What_if_Fs_TextBox.Focused Then
            Main.BCD.Cabinet.Woofer.Fs = Val(What_if_Fs_TextBox.Text)
            Call EBP_TrackBar_Scroll(Nothing, Nothing)      'Update EBS if Fs changes
            Call Derived.Calc_derived() 'update the derived parameters
            Call Update_Calculated_Values()       'Update the text boxes
            What_if_Fs_TextBox.Focus()
        End If
    End Sub

    Private Sub Qts_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles What_if_Qts_TextBox.TextChanged
        If load_flag And What_if_Qts_TextBox.Focused Then
            Main.BCD.Cabinet.Woofer.Qts = Val(What_if_Qts_TextBox.Text)
            Main.BCD.Cabinet.Woofer.Qes = 1.05 * Main.BCD.Cabinet.Woofer.Qts
            Main.BCD.Cabinet.Woofer.Qms = Main.BCD.Cabinet.Woofer.Qts / 0.047619
            If Main.BCD.Cabinet.Woofer.Qts > 0.1 Then
                What_if_Qts_TextBox.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Color_options.textbox_color_back_HTML)

                Call EBP_TrackBar_Scroll(Nothing, Nothing)      'Update EBS if Qts changes
                If What_if_Qts_TextBox.Focused Then
                    Call Derived.Calc_derived() 'update the derived parameters if user changes the value
                    Call Update_Calculated_Values()       'Update the text boxes
                    What_if_Qts_TextBox.Focus()
                End If
            Else
                What_if_Qts_TextBox.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Color_options.error_color_HTML)
            End If
        Else

        End If
    End Sub

    Private Sub Qts_edit_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles What_if_Qts_edit_Button.Click
        Dim Qts_window As New Qts_calc_Whatif
        'copy driver1 parameters into common variable
        'Derived.speaker = Main.BCD.Spkr.driver1.TS_Parameters
        Qts_window.ShowDialog()
        'Main.BCD.Cabinet.Woofer = Derived.speaker
        What_if_Qts_TextBox.Text = Str(Math.Round(Derived.Qts, 2))
        Call Derived.Calc_derived()
    End Sub

    Private Sub Sd_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles What_if_Sd_TextBox.TextChanged
        Dim Sd_temp As Double
        If What_if_Sd_TextBox.Focused Then
            Sd_temp = Val(What_if_Sd_TextBox.Text)
            Main.BCD.Cabinet.Woofer.Sd = Units.Convert_to_cm2(Sd_temp, SD_Units_Flag) 'convert to common units
            Call Derived.Calc_derived() 'update the derived parameters if user changes the value
            Call Update_Calculated_Values()       'Update the text boxes
            What_if_Sd_TextBox.Focus()
        End If
    End Sub

    Private Sub Vas_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles What_if_Vas_TextBox.TextChanged
        Dim Vas_temp As Double
        If What_if_Vas_TextBox.Focused = True Then  'only update the variable if the text box has focus
            Vas_temp = Val(What_if_Vas_TextBox.Text)     'hold the input data
            If Vas_temp > 0 Then
                What_if_Vas_TextBox.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Color_options.textbox_color_back_HTML)
                Main.BCD.Cabinet.Woofer.Vas = Units.Convert_to_Liters(Vas_temp, Vas_Units_Flag)     'convert to Liters
                Call Derived.Calc_derived() 'update the derived parameters
                Call Update_Calculated_Values()       'Update the text boxes
                What_if_Vas_TextBox.Focus()
            Else
                What_if_Vas_TextBox.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Color_options.error_color_HTML)
            End If
        End If
    End Sub

    Private Sub Re_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles What_if_Re_TextBox.TextChanged
        If What_if_Re_TextBox.Focused Then
            Main.BCD.Cabinet.Woofer.Re = Val(What_if_Re_TextBox.Text)
            Call Derived.Calc_derived() 'update the derived parameters if user changes the value
            Call Update_Calculated_Values()       'Update the text boxes
            What_if_Re_TextBox.Focus()
        End If
    End Sub

    Private Sub Re_edit_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles What_if_Re_edit_Button.Click
        Dim DCR_window As New DCR_calc
        Derived.speaker = Main.BCD.Cabinet.Woofer
        DCR_window.ShowDialog()
        'copy derived parameters to text boxes for display
        Main.BCD.Cabinet.Woofer = Derived.speaker
        DCR_window.Driver_res.Text = Math.Round(Main.BCD.Cabinet.Woofer.Re / Main.BCD.Cabinet.Woofer.Config.ReX, 3)
        Call Derived.Calc_derived() 'update the derived parameters
        Call Update_Calculated_Values()       'Update the text boxes
    End Sub

    Private Sub Xmax_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles What_if_Xmax_TextBox.TextChanged
        If What_if_Xmax_TextBox.Focused Then
            Main.BCD.Cabinet.Woofer.Xmax = Val(What_if_Xmax_TextBox.Text)
            Call Derived.Calc_derived() 'update the derived parameters if user changes the value
            Call Update_Calculated_Values()       'Update the text boxes
            What_if_Xmax_TextBox.Focus()
        End If
    End Sub

    Public Sub EBP_TrackBar_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim temp As Double
        temp = Math.Round(Main.BCD.Cabinet.Woofer.Fs / Main.BCD.Cabinet.Woofer.Qes, 0)
        What_if_EBP_TextBox.Text = temp.ToString
        If temp > 90 Then
            What_if_EBP_TrackBar.Value = 90
        ElseIf temp < 50 Then
            What_if_EBP_TrackBar.Value = 50
        Else
            What_if_EBP_TrackBar.Value = temp
        End If
    End Sub

#End Region

#Region "Units Buttons"

    Private Sub Vas_units_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles What_if_Vas_units_Button.Click
        'Cycles through:  Liters (L), Meters^3 (M), In^3 (I), and Ft^3 (F)
        Vas_Units_Flag = Units.Next_Liters_conv_flag(Vas_Units_Flag)   'figure out next unit
        What_if_Vas_units_Button.Text = Units.Liters_conv_text(Vas_Units_Flag)   'figure out button text
        What_if_Vas_TextBox.Text = Units.Liters_to_units(Main.BCD.Cabinet.Woofer.Vas, Vas_Units_Flag)
        'Change other Vas text as well
        Woofer_Vas_label.Text = "Vas: " & Units.Liters_to_units(Main.BCD.Spkr.driver1.TS_Parameters.Vas, Vas_Units_Flag)
        Mid1_Vas_label.Text = "Vas: " & Units.Liters_to_units(Main.BCD.Spkr.driver2.TS_Parameters.Vas, Vas_Units_Flag)
    End Sub

    Private Sub Sd_units_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles What_if_Sd_units_Button.Click
        'Cycles through:  m^2 (M), cm^2 (C)and In^2 (I)
        SD_Units_Flag = Units.Next_SD_conv_flag(SD_Units_Flag)   'figure out next unit
        What_if_Sd_units_Button.Text = Units.SD_conv_text(SD_Units_Flag)   'figure out button text
        What_if_Sd_TextBox.Text = Units.SD_to_units(Main.BCD.Cabinet.Woofer.Sd, SD_Units_Flag)
        'Update other SD displays as well
        Woofer_Sd_label.Text = "Sd: " & Units.SD_to_units(Main.BCD.Spkr.driver1.TS_Parameters.Sd, SD_Units_Flag)
        Mid1_Sd_label.Text = "Sd: " & Units.SD_to_units(Main.BCD.Spkr.driver2.TS_Parameters.Sd, SD_Units_Flag)
    End Sub

    Private Sub Sealed_Vol_units_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Sealed_Vol_units_Button.Click
        Call Update_Volume_textboxes()
    End Sub

    Sub Update_Volume_textboxes()
        'Cycles through:  Liters (L), Meters^3 (M), In^3 (I), and Ft^3 (F)
        Cabinet_vol_Units_Flag = Units.Next_Liters_conv_flag(Cabinet_vol_Units_Flag)   'figure out next unit

        Sealed_Vol_units_Button.Text = Units.Liters_conv_text(Cabinet_vol_Units_Flag)   'sealed volume button out button text
        Vented_Vol_units_button.Text = Units.Liters_conv_text(Cabinet_vol_Units_Flag)   'vented volume button button text
        PR_Volume_Units_Button.Text = Units.Liters_conv_text(Cabinet_vol_Units_Flag)   'figure out button text

        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                Sealed_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver1.Enclosure.Volume_sealed, Cabinet_vol_Units_Flag)
                Vented_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver1.Enclosure.Volume_vented, Cabinet_vol_Units_Flag)
                PR_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver1.Enclosure.Volume_PR, Cabinet_vol_Units_Flag)
            Case Selected_Woofer_box.mid1
                Sealed_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver2.Enclosure.Volume_sealed, Cabinet_vol_Units_Flag)
                Vented_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver2.Enclosure.Volume_vented, Cabinet_vol_Units_Flag)
                PR_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver2.Enclosure.Volume_PR, Cabinet_vol_Units_Flag)
            Case Selected_Woofer_box.what_if
                Sealed_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Cabinet.Box.Volume_sealed, Cabinet_vol_Units_Flag)
                Vented_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Cabinet.Box.Volume_vented, Cabinet_vol_Units_Flag)
                PR_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Cabinet.Box.Volume_vented, Cabinet_vol_Units_Flag)
        End Select
    End Sub


    Private Sub Vented_Vb_units_button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Vented_Vol_units_button.Click
        Call Update_Volume_textboxes()
    End Sub

    Private Sub Diam_Vents_Units_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Diam_Vents_Units_Button.Click, Len_Vents_Units_Button.Click
        'Cycles through:  m (M), cm (C)and In (I)
        Diam_Len_Vents_Units_Flag = Units.Next_Len_conv_flag(Diam_Len_Vents_Units_Flag)   'figure out next unit
        Diam_Vents_Units_Button.Text = Units.Len_conv_text(Diam_Len_Vents_Units_Flag)   'figure out button text
        Len_Vents_Units_Button.Text = Units.Len_conv_text(Diam_Len_Vents_Units_Flag)   'figure out button text

        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                Diameter_Vents_TextBox.Text = Units.Len_to_units(Main.BCD.Spkr.driver1.Enclosure.Vent.Dv, Diam_Len_Vents_Units_Flag)
                Calc_Vent_Len_TextBox.Text = Units.Len_to_units(Main.BCD.Spkr.driver1.Enclosure.Vent.Lv, Diam_Len_Vents_Units_Flag)
            Case Selected_Woofer_box.mid1
                Diameter_Vents_TextBox.Text = Units.Len_to_units(Main.BCD.Spkr.driver2.Enclosure.Vent.Dv, Diam_Len_Vents_Units_Flag)
                Calc_Vent_Len_TextBox.Text = Units.Len_to_units(Main.BCD.Spkr.driver2.Enclosure.Vent.Lv, Diam_Len_Vents_Units_Flag)
            Case Selected_Woofer_box.what_if
                Diameter_Vents_TextBox.Text = Units.Len_to_units(Main.BCD.Cabinet.Box.Vent.Dv, Diam_Len_Vents_Units_Flag)
                Calc_Vent_Len_TextBox.Text = Units.Len_to_units(Main.BCD.Cabinet.Box.Vent.Lv, Diam_Len_Vents_Units_Flag)
        End Select
    End Sub

    Private Sub PR_Volume_Units_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_Volume_Units_Button.Click
        Call Update_Volume_textboxes()
    End Sub

#End Region

#Region "Enclosure Data Text Boxes"

#Region "Sealed"

    Private Sub Sealed_Vol_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Sealed_Vol_TextBox.TextChanged
        Dim temp As Double
        If Sealed_Vol_TextBox.Focused Then
            temp = Val(Sealed_Vol_TextBox.Text)
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Volume_sealed = Convert_to_Liters(temp, Cabinet_vol_Units_Flag)
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Volume_sealed = Convert_to_Liters(temp, Cabinet_vol_Units_Flag)
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Volume_sealed = Convert_to_Liters(temp, Cabinet_vol_Units_Flag)
            End Select
            Call Derived.Calc_derived() 'update the derived parameters
            Call Update_Calculated_Values()       'Update the text boxes
            Sealed_Calc_Vol_button.Checked = False
            Sealed_Baffle_Vol_button.Checked = False
            Sealed_Vol_TextBox.Focus()
        End If
    End Sub

    Private Sub Sealed_Vol_TextBox_mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Sealed_Vol_TextBox.MouseWheel
        'let the text routine do the updating
        Select Case Cabinet_vol_Units_Flag
            Case "L"
                Sealed_Vol_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "V", Val(Sealed_Vol_TextBox.Text)), 1))
            Case "F"
                Sealed_Vol_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "V", Val(Sealed_Vol_TextBox.Text)), 2))
            Case "M"
                Sealed_Vol_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "V", Val(Sealed_Vol_TextBox.Text)), 3))
            Case "I"
                Sealed_Vol_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "V", Val(Sealed_Vol_TextBox.Text)), 0))
        End Select

    End Sub

    Private Sub Qb_edit_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Qb_edit_Button.Click
        Dim Qb_window As New Qb_edit
        Qb_window.ShowDialog()
        Call Derived.Calc_derived()
        Call Update_Calculated_Values()       'Update the text boxes
    End Sub

    Private Sub Sealed_Calc_Vol_button_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Sealed_Calc_Vol_button.CheckedChanged
        'copy Calc_Sealed_Vol into the XML variable and recalc
        If Sealed_Calc_Vol_button.Focused Then

            'update the sealed vol calculation
            Call Derived.Calc_derived()

            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Volume_sealed = Calc_Sealed_vol
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Volume_sealed = Calc_Sealed_vol
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Volume_sealed = Calc_Sealed_vol
            End Select
            'Sealed_vol_Units_Flag = "L"
            'Sealed_Vol_units_Button.Text = Liters_conv_text(Sealed_vol_Units_Flag)
            Sealed_Vol_TextBox.Focus()
            Sealed_Vol_TextBox.Text = Units.Liters_to_units(Calc_Sealed_vol, Cabinet_vol_Units_Flag)
            Sealed_Calc_Vol_button.Checked = True
        End If
    End Sub

    Private Sub Sealed_Baffle_Vol_button_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Sealed_Baffle_Vol_button.CheckedChanged
        'copy selected Baffle volume_Vol into the XML variable and recalc
        If Sealed_Baffle_Vol_button.Focused Then
            'Sealed_vol_Units_Flag = "L"
            'Sealed_Vol_units_Button.Text = Liters_conv_text(Sealed_vol_Units_Flag)
            Sealed_Vol_TextBox.Focus()

            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Volume_sealed = Main.BCD.Spkr.driver1.Enclosure.Misc_dimensions.Net_volume
                    Sealed_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver1.Enclosure.Volume_sealed, Cabinet_vol_Units_Flag)
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Volume_sealed = Main.BCD.Spkr.driver2.Enclosure.Misc_dimensions.Net_volume
                    Sealed_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver1.Enclosure.Volume_sealed, Cabinet_vol_Units_Flag)
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Volume_sealed = Main.BCD.Spkr.driver1.Enclosure.Misc_dimensions.Net_volume
                    Sealed_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver1.Enclosure.Volume_sealed, Cabinet_vol_Units_Flag)
            End Select
            Sealed_Baffle_Vol_button.Checked = True
        End If
    End Sub

#End Region

#Region "Vented"

    Private Sub Vented_Vol_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Vented_Vol_TextBox.TextChanged
        Dim temp As Double
        If Vented_Vol_TextBox.Focused Then
            temp = Val(Vented_Vol_TextBox.Text)
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Volume_vented = Convert_to_Liters(temp, Cabinet_vol_Units_Flag)
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Volume_vented = Convert_to_Liters(temp, Cabinet_vol_Units_Flag)
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Volume_vented = Convert_to_Liters(temp, Cabinet_vol_Units_Flag)
            End Select
            Call Derived.Calc_derived() 'update the derived parameters
            Call Update_Calculated_Values()       'Update the text boxes
            Vented_Calc_Vol_button.Checked = False
            Vented_Baffle_Vol_button.Checked = False
            Vented_Vol_TextBox.Focus()
        End If
    End Sub


    Private Sub Vented_Calc_Vol_button_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Vented_Calc_Vol_button.CheckedChanged
        'copy Calc_Vented_Vol into the XML variable and recalc
        If Vented_Calc_Vol_button.Focused Then
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Volume_vented = Calc_Vented_vol
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Volume_vented = Calc_Vented_vol
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Volume_vented = Calc_Vented_vol
            End Select
            Vented_Vol_TextBox.Focus()
            Vented_Vol_TextBox.Text = Units.Liters_to_units(Calc_Vented_vol, Cabinet_vol_Units_Flag)
            Vented_Calc_Vol_button.Checked = True
        End If
    End Sub


    Private Sub Vented_Baffle_Vol_button_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Vented_Baffle_Vol_button.CheckedChanged
        'this is the volume from the Baffle module
        'copy Calc_Vented_Vol into the XML variable and recalc
        If Vented_Baffle_Vol_button.Focused Then

            Vented_Vol_TextBox.Focus()
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Volume_vented = Main.BCD.Spkr.driver1.Enclosure.Misc_dimensions.Net_volume
                    Vented_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver1.Enclosure.Volume_vented, Cabinet_vol_Units_Flag)
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Volume_vented = Main.BCD.Spkr.driver2.Enclosure.Misc_dimensions.Net_volume
                    Vented_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver2.Enclosure.Volume_vented, Cabinet_vol_Units_Flag)
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Volume_vented = Main.BCD.Spkr.driver1.Enclosure.Misc_dimensions.Net_volume
                    Vented_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver1.Enclosure.Volume_vented, Cabinet_vol_Units_Flag)
            End Select
            Vented_Baffle_Vol_button.Checked = True
        End If

    End Sub

    Private Sub Vented_Vol_TextBox_mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Vented_Vol_TextBox.MouseWheel
        'let the text routine do the updating
        Select Case Cabinet_vol_Units_Flag
            Case "L"
                Vented_Vol_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "V", Val(Vented_Vol_TextBox.Text)), 1))
            Case "F"
                Vented_Vol_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "V", Val(Vented_Vol_TextBox.Text)), 2))
            Case "M"
                Vented_Vol_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "V", Val(Vented_Vol_TextBox.Text)), 3))
            Case "I"
                Vented_Vol_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "V", Val(Vented_Vol_TextBox.Text)), 0))
        End Select
    End Sub

    Private Sub Qb_edit_button_vented_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Qb_edit_button_vented.Click, Qb_edit_button_PR.Click
        Dim Qb_window As New Qb_edit
        Qb_window.ShowDialog()
        Call Derived.Calc_derived()
        Call Update_Calculated_Values()       'Update the text boxes
    End Sub

    Private Sub Vented_Fb_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Vented_Fb_TextBox.TextChanged
        If Vented_Fb_TextBox.Focused Then
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Target_Fb = Val(Vented_Fb_TextBox.Text)
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Target_Fb = Val(Vented_Fb_TextBox.Text)
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Target_Fb = Val(Vented_Fb_TextBox.Text)
            End Select

            If Update_Fb_from_Lv_flag = False Then
                Call Derived.Calc_derived() 'update the derived parameters
                Call Update_Calculated_Values()       'Update the text boxes
                If Referral_flag = False Then
                    Vented_Calc_Fb_button.Checked = False
                Else
                    Referral_flag = False
                End If
                Vented_Fb_TextBox.Focus()
            End If
        End If
    End Sub

    Private Sub Vented_Fb_TextBox_mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Vented_Fb_TextBox.MouseWheel
        'let the text routine do the updating
        If Update_Fb_from_Lv_flag = False Then
            Vented_Fb_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "F", Val(Vented_Fb_TextBox.Text)), 1))
        End If
    End Sub

    Private Sub Vented_Calc_Fb_button_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Vented_Calc_Fb_button.CheckedChanged
        'copy Calc_Vented_Vol into the XML variable and recalc
        'only do this if initiated by a mouse click...not code
        If Vented_Calc_Fb_button.Focused Then
            If Vented_Calc_Fb_button.Focused And Vented_Calc_Fb_button.Checked Then

                'force "Allow port size to change Fb" button off and make length readonly
                Vented_Calc_Len_button.Checked = False
                Update_Fb_from_Lv_flag = False
                Calc_Vent_Len_TextBox.ReadOnly = True
                Calc_Vent_Len_TextBox.BackColor = SystemColors.Control
                Vented_Fb_TextBox.ReadOnly = False
                Vented_Fb_TextBox.BackColor = SystemColors.Window

                Select Case Selected_Driver
                    Case Selected_Woofer_box.woofer
                        Main.BCD.Spkr.driver1.Enclosure.Target_Fb = Calc_Vented_Fb
                    Case Selected_Woofer_box.mid1
                        Main.BCD.Spkr.driver2.Enclosure.Target_Fb = Calc_Vented_Fb
                    Case Selected_Woofer_box.what_if
                        Main.BCD.Cabinet.Box.Target_Fb = Calc_Vented_Fb
                End Select
                Referral_flag = True
                Vented_Fb_TextBox.Focus()
                Vented_Fb_TextBox.Text = Math.Round(Calc_Vented_Fb, 1)
            End If
        End If
    End Sub

    Private Sub Qty_Vents_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Qty_Vents_TextBox.TextChanged
        If Qty_Vents_TextBox.Focused Then
            If Val(Qty_Vents_TextBox.Text) > 0 Then
                Select Case Selected_Driver
                    Case Selected_Woofer_box.woofer
                        Main.BCD.Spkr.driver1.Enclosure.Vent.Nv = Val(Qty_Vents_TextBox.Text)
                    Case Selected_Woofer_box.mid1
                        Main.BCD.Spkr.driver2.Enclosure.Vent.Nv = Val(Qty_Vents_TextBox.Text)
                    Case Selected_Woofer_box.what_if
                        Main.BCD.Cabinet.Box.Vent.Nv = Val(Qty_Vents_TextBox.Text)
                End Select
                Call Derived.Calc_derived() 'update the derived parameters
                Call Update_Calculated_Values()       'Update the text boxes
                Qty_Vents_TextBox.Focus()
                Qty_Vents_TextBox.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Color_options.textbox_color_back_HTML)
            Else
                Qty_Vents_TextBox.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Color_options.error_color_HTML)
            End If
        End If
    End Sub

    Private Sub Qty_Vents_TextBox_mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Qty_Vents_TextBox.MouseWheel
        'let the text routine do the updating
        Qty_Vents_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "Q", Val(Qty_Vents_TextBox.Text)), 1))
    End Sub

    Private Sub Diameter_Vents_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Diameter_Vents_TextBox.TextChanged
        Dim temp As Double
        If Diameter_Vents_TextBox.Focused Then
            temp = Val(Diameter_Vents_TextBox.Text)
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Vent.Dv = Convert_to_inches(temp, Diam_Len_Vents_Units_Flag) 'convert to native units
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Vent.Dv = Convert_to_inches(temp, Diam_Len_Vents_Units_Flag)
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Vent.Dv = Convert_to_inches(temp, Diam_Len_Vents_Units_Flag)
            End Select
            Call Derived.Calc_derived() 'update the derived parameters
            Call Update_Calculated_Values()       'Update the text boxes
            Vented_Calc_Diam_button.Checked = False
            Diameter_Vents_TextBox.Focus()
        End If
    End Sub

    Private Sub Diameter_Vents_TextBox_mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Diameter_Vents_TextBox.MouseWheel
        'let the text routine do the updating
        'Diameter_Vents_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "F", Val(Diameter_Vents_TextBox.Text)), 1))

        Select Case Diam_Len_Vents_Units_Flag
            Case "C"
                Diameter_Vents_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "F", Val(Diameter_Vents_TextBox.Text)), 2))
            Case "M"
                Diameter_Vents_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "F", Val(Diameter_Vents_TextBox.Text)), 3))
            Case "I"
                Diameter_Vents_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "F", Val(Diameter_Vents_TextBox.Text)), 1))
        End Select

    End Sub

    Private Sub Vented_Calc_Diam_button_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Vented_Calc_Diam_button.CheckedChanged
        'copy Calc_Vented_Vol into the XML variable and recalc
        If Vented_Calc_Diam_button.Focused Then
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Vent.Dv = P_diam_min
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Vent.Dv = P_diam_min
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Vent.Dv = P_diam_min
            End Select
            'Diam_Vents_Units_Flag = "I"
            'Diam_Vents_Units_Button.Text = Len_conv_text(Diam_Vents_Units_Flag)
            Diameter_Vents_TextBox.Focus()
            Diameter_Vents_TextBox.Text = Len_to_units(P_diam_min, Diam_Len_Vents_Units_Flag)
            Vented_Calc_Diam_button.Checked = True
        End If
    End Sub

    Private Sub Calc_Vent_Len_TextBox_TextChanged(sender As Object, e As EventArgs) Handles Calc_Vent_Len_TextBox.TextChanged
        Dim temp As Double
        Dim new_target As Double

        If Calc_Vent_Len_TextBox.Focused Then

            temp = Val(Calc_Vent_Len_TextBox.Text)

            If Update_Fb_from_Lv_flag Then
                Derived.Update_Fb_from_Lv(temp, new_target)
                Vented_Fb_TextBox.Text = Math.Round(new_target, 2)
            End If

            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Vent.Lv = temp
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Vent.Lv = temp
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Vent.Lv = temp
            End Select

            Call Derived.Calc_derived() 'update the derived parameters

            Vented_Calc_Fb_button.Checked = False
            Calc_Vent_Len_TextBox.Focus()

        End If
    End Sub


    Private Sub Calc_Vent_Len_TextBox_mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Calc_Vent_Len_TextBox.MouseWheel
        'let the text routine do the updating
        If Update_Fb_from_Lv_flag = True Then
            Calc_Vent_Len_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "L", Val(Calc_Vent_Len_TextBox.Text)), 1))
        End If
    End Sub

    Private Sub CheckBox1_CheckedChanged(sender As Object, e As EventArgs) Handles Vented_Calc_Len_button.CheckedChanged
        'only do this if initiated by a mouse click...not code
        If Vented_Calc_Len_button.Focused Then

            If Vented_Calc_Len_button.Checked Then
                Update_Fb_from_Lv_flag = True
                Calc_Vent_Len_TextBox.ReadOnly = False
                Calc_Vent_Len_TextBox.BackColor = SystemColors.Window

                'force "Optimal Fb" button off and make Fb readonly
                Vented_Calc_Fb_button.Checked = False
                Update_Fb_from_Lv_flag = True
                Vented_Fb_TextBox.ReadOnly = True
                Vented_Fb_TextBox.BackColor = SystemColors.Control

            Else
                Update_Fb_from_Lv_flag = False
                Calc_Vent_Len_TextBox.ReadOnly = True
                Calc_Vent_Len_TextBox.BackColor = SystemColors.Control

                'unchecked:  Fb readable
                Vented_Fb_TextBox.ReadOnly = False
                Vented_Fb_TextBox.BackColor = SystemColors.Window

            End If
        End If
    End Sub

#End Region

#Region "Passive Radiator"
    Private Sub PR_Vol_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_Vol_TextBox.TextChanged
        Dim temp As Double
        If PR_Vol_TextBox.Focused Then
            temp = Val(PR_Vol_TextBox.Text)
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Volume_PR = Convert_to_Liters(temp, Cabinet_vol_Units_Flag)
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Volume_PR = Convert_to_Liters(temp, Cabinet_vol_Units_Flag)
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Volume_PR = Convert_to_Liters(temp, Cabinet_vol_Units_Flag)
            End Select
            Call Derived.Calc_derived() 'update the derived parameters
            Call Update_Calculated_Values()       'Update the text boxes
            PR_Calc_Vol_button.Checked = False
            PR_Baffle_Vol_button.Checked = False
            PR_Vol_TextBox.Focus()
        End If
    End Sub

    Private Sub PR_Vol_TextBox_mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PR_Vol_TextBox.MouseWheel
        'let the text routine do the updating
        PR_Vol_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "V", Val(PR_Vol_TextBox.Text)), 1))
    End Sub

    Private Sub PR_Calc_Vol_button_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_Calc_Vol_button.CheckedChanged
        'copy Calc_PR_Vol into the XML variable and recalc
        If PR_Calc_Vol_button.Focused Then
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Volume_PR = Calc_PR_Vol
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Volume_PR = Calc_PR_Vol
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Volume_PR = Calc_PR_Vol
            End Select
            'PR_vol_Units_Flag = "L"
            'PR_Volume_Units_Button.Text = Liters_conv_text(PR_vol_Units_Flag)
            PR_Vol_TextBox.Focus()
            PR_Vol_TextBox.Text = Units.Liters_to_units(Calc_PR_Vol, Cabinet_vol_Units_Flag)
            PR_Calc_Vol_button.Checked = True
        End If
    End Sub

    Private Sub PR_Baffle_Vol_button_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_Baffle_Vol_button.CheckedChanged
        'this is the volume from the Baffle module
        'copy Calc_Vented_Vol into the XML variable and recalc
        If PR_Baffle_Vol_button.Focused Then

            'PR_vol_Units_Flag = "L"
            'PR_Volume_Units_Button.Text = Liters_conv_text(PR_vol_Units_Flag)
            PR_Vol_TextBox.Focus()
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Volume_PR = Main.BCD.Spkr.driver1.Enclosure.Misc_dimensions.Net_volume
                    PR_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver1.Enclosure.Volume_PR, Cabinet_vol_Units_Flag)
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Volume_vented = Main.BCD.Spkr.driver2.Enclosure.Misc_dimensions.Net_volume
                    PR_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver2.Enclosure.Volume_PR, Cabinet_vol_Units_Flag)
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Volume_vented = Main.BCD.Spkr.driver1.Enclosure.Misc_dimensions.Net_volume
                    PR_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver1.Enclosure.Volume_PR, Cabinet_vol_Units_Flag)
            End Select
            PR_Baffle_Vol_button.Checked = True
        End If
    End Sub

    Private Sub PR_QB_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_QB_TextBox.TextChanged
        'Read-only, so no code needed:  same as Vented
    End Sub

    Private Sub PR_Fb_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_Fb_TextBox.TextChanged
        If PR_Fb_TextBox.Focused Then
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Target_Fb = Val(PR_Fb_TextBox.Text)
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Target_Fb = Val(PR_Fb_TextBox.Text)
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Target_Fb = Val(PR_Fb_TextBox.Text)
            End Select
            Call Derived.Calc_derived() 'update the derived parameters
            Call Update_Calculated_Values()     'Update the text boxes
            If Referral_flag = False Then
                PR_Calc_Fb_button.Checked = False
            Else
                Referral_flag = False
            End If
            PR_Fb_TextBox.Focus()               'Restore Focus
        End If
    End Sub

    Private Sub PR_Fb_TextBox_mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PR_Fb_TextBox.MouseWheel
        'let the text routine do the updating
        PR_Fb_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "F", Val(PR_Fb_TextBox.Text)), 1))
    End Sub

    Private Sub PR_Calc_Fb_button_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_Calc_Fb_button.CheckedChanged
        'copy Calc_Vented_Fb into the XML variable and recalc
        If PR_Calc_Fb_button.Focused And PR_Calc_Fb_button.Checked Then
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.Target_Fb = Calc_Vented_Fb
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.Target_Fb = Calc_Vented_Fb
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.Target_Fb = Calc_Vented_Fb
            End Select
            Referral_flag = True
            PR_Fb_TextBox.Focus()
            PR_Fb_TextBox.Text = Math.Round(Calc_Vented_Fb, 1)
        End If
    End Sub

    Private Sub PR_Qty_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_Qty_TextBox.TextChanged
        If PR_Qty_TextBox.Focused Then
            If Val(PR_Qty_TextBox.Text) > 0 Then
                Select Case Selected_Driver
                    Case Selected_Woofer_box.woofer
                        Main.BCD.Spkr.driver1.Enclosure.PR.Np = Val(PR_Qty_TextBox.Text)
                    Case Selected_Woofer_box.mid1
                        Main.BCD.Spkr.driver2.Enclosure.PR.Np = Val(PR_Qty_TextBox.Text)
                    Case Selected_Woofer_box.what_if
                        Main.BCD.Cabinet.Box.PR.Np = Val(PR_Qty_TextBox.Text)
                End Select
                Call Derived.Calc_derived() 'update the derived parameters
                Call Update_Calculated_Values()       'Update the text boxes
                PR_Qty_TextBox.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Color_options.textbox_color_back_HTML)
                PR_Qty_TextBox.Focus()
            Else
                PR_Qty_TextBox.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Color_options.error_color_HTML)
            End If
        End If
    End Sub

    Private Sub PR_Qty_PR_TextBox_mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PR_Qty_TextBox.MouseWheel
        'let the text routine do the updating
        PR_Qty_TextBox.Text = Str(Get_next_calculated_value(e.Delta, "Q", Val(PR_Qty_TextBox.Text)))
    End Sub

    Private Sub PR_AddedMass_TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_AddedMass_TextBox.TextChanged
        If PR_AddedMass_TextBox.Focused Then
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.PR.Mass_added = Val(PR_AddedMass_TextBox.Text)
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.PR.Mass_added = Val(PR_AddedMass_TextBox.Text)
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.PR.Mass_added = Val(PR_AddedMass_TextBox.Text)
            End Select
            Call Derived.Calc_derived() 'update the derived parameters
            Call Update_Calculated_Values()       'Update the text boxes
            If Referral_flag = False Then
                PR_Calc_Mass_checkbox.Checked = False
            Else
                Referral_flag = False
            End If
            PR_AddedMass_TextBox.Focus()
        End If
    End Sub

    Private Sub PR_AddedMass_TextBox_mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PR_AddedMass_TextBox.MouseWheel
        'let the text routine do the updating
        PR_AddedMass_TextBox.Text = Str(Math.Round(Get_next_calculated_value(e.Delta, "F", Val(PR_AddedMass_TextBox.Text)), 1))
    End Sub

    Private Sub PR_Calc_Mass_checkbox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PR_Calc_Mass_checkbox.CheckedChanged
        'copy Calc_Mass into the XML variable and recalc
        If PR_Calc_Mass_checkbox.Focused And PR_Calc_Mass_checkbox.Checked Then
            Select Case Selected_Driver
                Case Selected_Woofer_box.woofer
                    Main.BCD.Spkr.driver1.Enclosure.PR.Mass_added = Mass_to_add
                Case Selected_Woofer_box.mid1
                    Main.BCD.Spkr.driver2.Enclosure.PR.Mass_added = Mass_to_add
                Case Selected_Woofer_box.what_if
                    Main.BCD.Cabinet.Box.PR.Mass_added = Mass_to_add
            End Select
            Referral_flag = True
            PR_AddedMass_TextBox.Focus()
            PR_AddedMass_TextBox.Text = Math.Round(Mass_to_add, 1)
        End If
    End Sub

#End Region

#End Region

#Region "Mouse Wheel"
    'Mouse Wheel Routine

    'Mouse wheel parts selection

    Function Get_next_calculated_value(ByVal mouse_direction, ByVal component_type, ByVal current_value)
        'Dim Vol_Range As Integer
        Get_next_calculated_value = 0
        Select Case component_type

            Case "V", "F"
                'mouse wheel up;  get next higher value in the list
                If mouse_direction > 0 And current_value < 100000 Then
                    Get_next_calculated_value = current_value * 1.05
                ElseIf mouse_direction < 0 And current_value > 0.00001 Then
                    Get_next_calculated_value = current_value * 0.95
                Else
                    Get_next_calculated_value = current_value
                End If

            Case "Q"
                'mouse wheel up;  get next higher value in the list
                If mouse_direction > 0 And current_value < 4 Then
                    Get_next_calculated_value = current_value + 1
                ElseIf mouse_direction < 0 And current_value > 1 Then
                    Get_next_calculated_value = current_value - 1
                Else
                    Get_next_calculated_value = current_value
                End If

            Case "L"
                'mouse wheel up;  get next higher value in the list
                If mouse_direction > 0 And current_value < 40 Then
                    Get_next_calculated_value = current_value + 0.5
                ElseIf mouse_direction < 0 And current_value > 0.5 Then
                    Get_next_calculated_value = current_value - 0.5
                Else
                    Get_next_calculated_value = current_value
                End If
        End Select

    End Function

#End Region

#Region "Load and Save Routines"
    'Save Spliced Data
    Private Sub Save_Spliced_Data_MenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Save_Spliced_Data_MenuItem.Click

        Dim save_dialog As New SaveFileDialog()
        Dim myStream As Stream = Nothing
        Dim file_name As String
        Dim linebuf As String
        Dim amp_temp As Double
        Dim phase_temp As Double
        Dim temp As Complex

        save_dialog.InitialDirectory = "My.Computer.FileSystem.SpecialDirectories.MyDocuments"
        save_dialog.Filter = "frd files (*.frd)|*.frd|All files (*.*)|*.*"

        If save_dialog.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            file_name = save_dialog.FileName
            Dim save_file As New System.IO.StreamWriter(file_name)

            For n = 0 To Main.Samples - 1
                temp = Main.Arrays.Driver_response.With_AC_offset_and_splice(Selected_Driver, n)
                amp_temp = 20 * Math.Log10(Mag(temp))
                phase_temp = Main.angletoradians * Math.Atan2(temp.Im, temp.Re)

                linebuf = Str(Math.Round(Main.Frequency(n), 2))
                linebuf = linebuf + "  "
                linebuf = linebuf + Str(Math.Round(amp_temp, 2))
                linebuf = linebuf + "  "
                linebuf = linebuf + Str(Math.Round(phase_temp, 2))
                save_file.WriteLine(linebuf)
            Next
            save_file.Close()
        End If

    End Sub

#End Region

#Region "Tab Controls"

    Private Sub Spec_PR_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Spec_PR_Button.Click
        'Dim PR_form As New PR_spec
        PR_form.ShowDialog()
        Call Update_Calculated_Values()
    End Sub

    Private Sub Box_Type_Tab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Box_type_TabControl.SelectedIndexChanged, Box_type_TabControl.SelectedIndexChanged
        Select Case Box_type_TabControl.SelectedIndex
            Case 0
                Enclosure_image.Image = My.Resources.sealed
                Box_type_TabControl.SelectedTab = Sealed
                Select Case Selected_Driver
                    Case Selected_Woofer_box.woofer
                        Main.BCD.Spkr.driver1.Enclosure.Box_Type = sealed_box
                    Case Selected_Woofer_box.mid1
                        Main.BCD.Spkr.driver2.Enclosure.Box_Type = sealed_box
                    Case Selected_Woofer_box.what_if
                        Main.BCD.Cabinet.Box.Box_Type = sealed_box
                End Select
                Call Derived.Calc_derived()
                Call Update_Calculated_Values()       'Update the text boxes
                Woofer_Splicebox.Refresh()
            Case 1
                Enclosure_image.Image = My.Resources.vented
                Box_type_TabControl.SelectedTab = Vented
                Select Case Selected_Driver
                    Case Selected_Woofer_box.woofer
                        Main.BCD.Spkr.driver1.Enclosure.Box_Type = vented_box
                    Case Selected_Woofer_box.mid1
                        Main.BCD.Spkr.driver2.Enclosure.Box_Type = vented_box
                    Case Selected_Woofer_box.what_if
                        Main.BCD.Cabinet.Box.Box_Type = vented_box
                End Select
                Call Derived.Calc_derived()
                Call Update_Calculated_Values()       'Update the text boxes
                Woofer_Splicebox.Refresh()
            Case 2
                Enclosure_image.Image = My.Resources.PR_box
                Box_type_TabControl.SelectedTab = PR
                Select Case Selected_Driver
                    Case Selected_Woofer_box.woofer
                        Main.BCD.Spkr.driver1.Enclosure.Box_Type = PR_box
                    Case Selected_Woofer_box.mid1
                        Main.BCD.Spkr.driver2.Enclosure.Box_Type = PR_box
                    Case Selected_Woofer_box.what_if
                        Main.BCD.Cabinet.Box.Box_Type = PR_box
                End Select
                Call Derived.Calc_derived()
                Call Update_Calculated_Values()       'Update the text boxes
                Woofer_Splicebox.Refresh()
        End Select
    End Sub

    Private Sub Woofer_Tab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Woofer_Tab_Control.SelectedIndexChanged
        Select Case Woofer_Tab_Control.SelectedIndex
            Case 0
                Selected_Driver = Selected_Woofer_box.woofer
            Case 1
                If Woofer_Tab_Control.TabCount = 3 Then
                    Selected_Driver = Selected_Woofer_box.mid1
                Else
                    Selected_Driver = Selected_Woofer_box.what_if
                End If
            Case 2
                Selected_Driver = Selected_Woofer_box.what_if
        End Select
        Call Update_Driver_Config(Get_Driver_Config(Selected_Driver))
        Call Box_Type_Tab_Click(Nothing, Nothing)

        Select Case Selected_Driver
            Case Selected_Woofer_box.woofer
                Sealed_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver1.Enclosure.Volume_sealed, Cabinet_vol_Units_Flag)
                Vented_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver1.Enclosure.Volume_vented, Cabinet_vol_Units_Flag)
                Vented_Fb_TextBox.Text = Str(Main.BCD.Spkr.driver1.Enclosure.Target_Fb)
                Qty_Vents_TextBox.Text = Str(Main.BCD.Spkr.driver1.Enclosure.Vent.Nv)
                Diameter_Vents_TextBox.Text = Units.Len_to_units(Main.BCD.Spkr.driver1.Enclosure.Vent.Dv, Diam_Len_Vents_Units_Flag)
                PR_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver1.Enclosure.Volume_PR, Cabinet_vol_Units_Flag)
                PR_Fb_TextBox.Text = Str(Main.BCD.Spkr.driver1.Enclosure.Target_Fb)
                PR_Qty_TextBox.Text = Str(Main.BCD.Spkr.driver1.Enclosure.PR.Np)
                PR_AddedMass_TextBox.Text = Str(Main.BCD.Spkr.driver1.Enclosure.PR.Mass_added)
            Case Selected_Woofer_box.mid1
                Sealed_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver2.Enclosure.Volume_sealed, Cabinet_vol_Units_Flag)
                Vented_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver2.Enclosure.Volume_vented, Cabinet_vol_Units_Flag)
                Vented_Fb_TextBox.Text = Str(Main.BCD.Spkr.driver2.Enclosure.Target_Fb)
                Qty_Vents_TextBox.Text = Str(Main.BCD.Spkr.driver2.Enclosure.Vent.Nv)
                Diameter_Vents_TextBox.Text = Units.Len_to_units(Main.BCD.Spkr.driver2.Enclosure.Vent.Dv, Diam_Len_Vents_Units_Flag)
                PR_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Spkr.driver2.Enclosure.Volume_PR, Cabinet_vol_Units_Flag)
                PR_Fb_TextBox.Text = Str(Main.BCD.Spkr.driver2.Enclosure.Target_Fb)
                PR_Qty_TextBox.Text = Str(Main.BCD.Spkr.driver2.Enclosure.PR.Np)
                PR_AddedMass_TextBox.Text = Str(Main.BCD.Spkr.driver2.Enclosure.PR.Mass_added)
            Case Selected_Woofer_box.what_if
                Sealed_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Cabinet.Box.Volume_sealed, Cabinet_vol_Units_Flag)
                Vented_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Cabinet.Box.Volume_vented, Cabinet_vol_Units_Flag)
                Vented_Fb_TextBox.Text = Str(Main.BCD.Cabinet.Box.Target_Fb)
                Qty_Vents_TextBox.Text = Str(Main.BCD.Cabinet.Box.Vent.Nv)
                Diameter_Vents_TextBox.Text = Units.Len_to_units(Main.BCD.Cabinet.Box.Vent.Dv, Diam_Len_Vents_Units_Flag)
                PR_Vol_TextBox.Text = Units.Liters_to_units(Main.BCD.Cabinet.Box.Volume_PR, Cabinet_vol_Units_Flag)
                PR_Fb_TextBox.Text = Str(Main.BCD.Cabinet.Box.Target_Fb)
                PR_Qty_TextBox.Text = Str(Main.BCD.Cabinet.Box.PR.Np)
                PR_AddedMass_TextBox.Text = Str(Main.BCD.Cabinet.Box.PR.Mass_added)

        End Select

        Call Qb_edit.Update_Qb()
        'Sealed_QB_TextBox.Text = Str(Main.BCD.Cabinet.Box.Qa)
        'need to calculate QB
    End Sub

#End Region

#Region "Scale buttons and chart options"
    Private Sub SPL_ScaleButton2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SPL_ScaleButton2.Click
        SPL_ScaleButton2.Checked = True
        SPL_ScaleButton1.Checked = False
        SPL_ScaleButton0.Checked = False
        Call Update_SPL_chart()
    End Sub

    Private Sub SPL_ScaleButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SPL_ScaleButton1.Click
        SPL_ScaleButton2.Checked = False
        SPL_ScaleButton1.Checked = True
        SPL_ScaleButton0.Checked = False
        Call Update_SPL_chart()
    End Sub

    Private Sub SPL_ScaleButton0_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SPL_ScaleButton0.Click
        SPL_ScaleButton2.Checked = False
        SPL_ScaleButton1.Checked = False
        SPL_ScaleButton0.Checked = True
        Call Update_SPL_chart()
    End Sub

    Private Sub Impedance_ScaleButton2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Impedance_ScaleButton2.Click
        Impedance_ScaleButton2.Checked = True
        Impedance_ScaleButton1.Checked = False
        Impedance_ScaleButton0.Checked = False
        Call Update_Impedance_chart()
    End Sub

    Private Sub Impedance_ScaleButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Impedance_ScaleButton1.Click
        Impedance_ScaleButton2.Checked = False
        Impedance_ScaleButton1.Checked = True
        Impedance_ScaleButton0.Checked = False
        Call Update_Impedance_chart()
    End Sub

    Private Sub Impedance_ScaleButton0_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Impedance_ScaleButton0.Click
        Impedance_ScaleButton2.Checked = False
        Impedance_ScaleButton1.Checked = False
        Impedance_ScaleButton0.Checked = True
        Call Update_Impedance_chart()
    End Sub

#End Region

#Region "Chart Updates and Initialization"

    'Chart Updates

    Public Sub Update_SPL_chart()

        'First find maximum for scaling
        max_value = 0
        For n = 0 To Main.Samples - 1
            If Total_SPL(Selected_Driver, n) > max_value Then
                max_value = Total_SPL(Selected_Driver, n)
            End If
        Next
        'Get scaling values
        Call Scale_button_calc.Find_min_max_SPL(max_value, max1db, min1db, max2db, min2db, max3db, min3db)

        'Dim Filter_sum() As Double = New Double(Main.Samples - 1) {}
        Woofer_SPL_Chart.Select()
        Woofer_SPL_Chart.Series(0).Points.Clear()
        Woofer_SPL_Chart.Series(1).Points.Clear()
        Woofer_SPL_Chart.Series(2).Points.Clear()
        For n = 0 To Main.Samples - 1

            Woofer_SPL_Chart.Series(0).Points.AddXY(Main.Frequency(n), Total_SPL(Selected_Driver, n))
            Woofer_SPL_Chart.Series(1).Points.AddXY(Main.Frequency(n), Cone_SPL(n))
            Woofer_SPL_Chart.Series(2).Points.AddXY(Main.Frequency(n), Vent_SPL(n))
        Next n

        If Derived.enclosure.Box_Type = vented_box Or Derived.enclosure.Box_Type = PR_box Then
            Woofer_SPL_Chart.Series.Item(0).BorderWidth = Main.BCD.Project.Chart_options.Line_thickness + 1
            Woofer_SPL_Chart.Series.Item(1).Enabled = True
            Woofer_SPL_Chart.Series.Item(2).Enabled = True
        Else
            Woofer_SPL_Chart.Series.Item(1).Enabled = False
            Woofer_SPL_Chart.Series.Item(2).Enabled = False
        End If

        'Now set the scale
        If SPL_ScaleButton2.Checked Then
            Woofer_SPL_Chart.ChartAreas.Item(0).AxisY.Maximum = max1db
            Woofer_SPL_Chart.ChartAreas.Item(0).AxisY.Minimum = min1db
        ElseIf SPL_ScaleButton0.Checked Then
            Woofer_SPL_Chart.ChartAreas.Item(0).AxisY.Maximum = max3db
            Woofer_SPL_Chart.ChartAreas.Item(0).AxisY.Minimum = min3db
        Else            'default
            Woofer_SPL_Chart.ChartAreas.Item(0).AxisY.Maximum = max2db
            Woofer_SPL_Chart.ChartAreas.Item(0).AxisY.Minimum = min2db
        End If

        F3_Label.Text = "F3 = " & Str(Math.Round(F3))
        F10_Label.Text = "F10 = " & Str(Math.Round(F10))
        F0_Label.Text = "Max SPL = " & Str(Math.Round(Derived.Max_output, 1))


    End Sub

    Public Sub Update_Excursion_chart()

        Excursion_Chart.Select()
        Excursion_Chart.Series(0).Points.Clear()
        Excursion_Chart.Series(1).Points.Clear()
        Excursion_Chart.Series(2).Points.Clear()
        Excursion_Chart.Series(3).Points.Clear()
        Excursion_Chart.Series(4).Points.Clear()

        Excursion_Chart.Series(1).BorderDashStyle = DataVisualization.Charting.ChartDashStyle.Dash
        Excursion_Chart.Series(3).BorderDashStyle = DataVisualization.Charting.ChartDashStyle.Dash
        Excursion_Chart.Series(0).Name = "Cone Excursion"
        Excursion_Chart.Series(1).Name = "Xmax"
        Excursion_Chart.Series(2).Name = "PR Excursion"
        Excursion_Chart.Series(3).Name = "PR Xmax"

        For n = 0 To Main.Samples - 1
            Excursion_Chart.Series(0).Points.AddXY(Main.Frequency(n), Cone_Excursion(n))
            Excursion_Chart.Series(1).Points.AddXY(Main.Frequency(n), Derived.speaker.Xmax)
            Excursion_Chart.Series(2).Points.AddXY(Main.Frequency(n), PR_Excursion(n))
            Excursion_Chart.Series(3).Points.AddXY(Main.Frequency(n), Derived.enclosure.PR.Xmax)
            Excursion_Chart.Series(4).Points.AddXY(Main.Frequency(n), Vent_Velocity(n))
        Next n

        'Determine whether Xmax, PR_Max or PR_Excursion lines should be shown
        If Derived.enclosure.Box_Type = PR_box Then
            Excursion_Chart.Series.Item(2).Enabled = True
            Excursion_Chart.Series.Item(3).Enabled = False
            Excursion_Chart.Series.Item(4).Enabled = False

            Peak_Cone_Excursion_label.Show()
            Peak_PR_Excursion_Label.Show()
            Peak_Vent_Velocity_Label.Hide()
            Peak_Cone_Excursion_label.Text = "Peak Cone Exc = " & Str(Math.Round(Peak_Cone_excursion, 1))
            Peak_PR_Excursion_Label.Text = "Peak PR Exc = " & Str(Math.Round(Peak_PR_excursion, 1))
            If Peak_Cone_excursion > Derived.speaker.Xmax Then
                Peak_Cone_Excursion_label.ForeColor = Color.Red
            Else
                Peak_Cone_Excursion_label.ForeColor = Color.Black
            End If
            If Peak_PR_excursion > Derived.enclosure.PR.Xmax Then
                Peak_PR_Excursion_Label.ForeColor = Color.Red
            Else
                Peak_PR_Excursion_Label.ForeColor = Color.Black
            End If


        ElseIf Derived.enclosure.Box_Type = vented_box Then
            Excursion_Chart.Series.Item(2).Enabled = False
            Excursion_Chart.Series.Item(3).Enabled = False
            Excursion_Chart.Series.Item(4).Enabled = True

            Peak_Cone_Excursion_label.Show()
            Peak_PR_Excursion_Label.Hide()
            Peak_Vent_Velocity_Label.Show()
            Peak_Cone_Excursion_label.Text = "Peak Cone Exc = " & Str(Math.Round(Peak_Cone_excursion, 1))
            Peak_Vent_Velocity_Label.Text = "Peak Vent Vel = " & Str(Math.Round(Peak_velocity, 1))
            If Peak_Cone_excursion > Derived.speaker.Xmax Then
                Peak_Cone_Excursion_label.ForeColor = Color.Red
            Else
                Peak_Cone_Excursion_label.ForeColor = Color.Black
            End If
            If Peak_velocity > 40 Then
                Peak_Vent_Velocity_Label.ForeColor = Color.Red
            Else
                Peak_Vent_Velocity_Label.ForeColor = Color.Black
            End If


        Else        'sealed
            Excursion_Chart.Series.Item(2).Enabled = False
            Excursion_Chart.Series.Item(3).Enabled = False
            Excursion_Chart.Series.Item(4).Enabled = False

            Peak_Cone_Excursion_label.Show()
            Peak_PR_Excursion_Label.Hide()
            Peak_Vent_Velocity_Label.Hide()
            Peak_Cone_Excursion_label.Text = "Peak Cone Exc = " & Str(Math.Round(Peak_Cone_excursion, 1))
            If Peak_Cone_excursion > Derived.speaker.Xmax Then
                Peak_Cone_Excursion_label.ForeColor = Color.Red
            Else
                Peak_Cone_Excursion_label.ForeColor = Color.Black
            End If
        End If

    End Sub

    Public Sub Update_Impedance_chart()

        'First find maximum for scaling
        max_value = 0
        For n = 0 To Main.Samples - 1
            If System_Impedance(n) > max_value Then
                max_value = System_Impedance(n)
            End If
        Next
        'Get scaling values
        Call Scale_button_calc.Find_min_max_Imp(max_value, max1db, min1db, max2db, min2db, max3db, min3db)

        Woofer_Impedance_Chart.Select()
        Woofer_Impedance_Chart.Series(0).Points.Clear()
        Woofer_Impedance_Chart.Series(1).Points.Clear()

        For n = 0 To Main.Samples - 1
            Woofer_Impedance_Chart.Series(0).Points.AddXY(Main.Frequency(n), System_Impedance(n))
            Woofer_Impedance_Chart.Series(1).Points.AddXY(Main.Frequency(n), System_Phase(n))
        Next

        'Now set the scale
        If Impedance_ScaleButton2.Checked Then
            Woofer_Impedance_Chart.ChartAreas.Item(0).AxisY.Maximum = max1db
            Woofer_Impedance_Chart.ChartAreas.Item(0).AxisY.Minimum = min1db
        ElseIf Impedance_ScaleButton0.Checked Then
            Woofer_Impedance_Chart.ChartAreas.Item(0).AxisY.Maximum = max3db
            Woofer_Impedance_Chart.ChartAreas.Item(0).AxisY.Minimum = min3db
        Else            'default
            Woofer_Impedance_Chart.ChartAreas.Item(0).AxisY.Maximum = max2db
            Woofer_Impedance_Chart.ChartAreas.Item(0).AxisY.Minimum = min2db
        End If

        Min_Imp_Label.Text = "Min Imp = " & Str(Math.Round(Min_Imp, 1))

    End Sub

    Public Sub Update_Power_chart()
        Power_Chart.Select()
        Power_Chart.Series(0).Points.Clear()
        Power_Chart.Series(1).Points.Clear()

        For n = 0 To Main.Samples - 1
            Power_Chart.Series(0).Points.AddXY(Main.Frequency(n), Amp_Power(n))
            Power_Chart.Series(1).Points.AddXY(Main.Frequency(n), Amp_Into_Impedance(n))
        Next
    End Sub


    'Initialization

    Public Sub SPL_chart_init()
        'Initial chart appearance by copying from the stored data
        Woofer_SPL_Chart.ChartAreas.Item(0).Area3DStyle.Enable3D = Main.BCD.Project.Chart_options.Area3DStyle
        Woofer_SPL_Chart.ChartAreas.Item(0).Area3DStyle.Inclination = Main.BCD.Project.Chart_options.Inclination
        Woofer_SPL_Chart.ChartAreas.Item(0).Area3DStyle.Rotation = Main.BCD.Project.Chart_options.Rotation
        Woofer_SPL_Chart.ChartAreas.Item(0).Area3DStyle.PointDepth = Main.BCD.Project.Chart_options.PointDepth
        Woofer_SPL_Chart.ChartAreas.Item(0).BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.chart_back_color_HTML)
        Woofer_SPL_Chart.ChartAreas.Item(0).BackSecondaryColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.chart_sec_back_color_HTML)
        Woofer_SPL_Chart.ChartAreas.Item(0).BackGradientStyle = Main.BCD.Project.Chart_options.Chart_gradient_style
        Woofer_SPL_Chart.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Background_color_HTML)
        Woofer_SPL_Chart.BackSecondaryColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Sec_back_color_HTML)
        Woofer_SPL_Chart.BackGradientStyle = Main.BCD.Project.Chart_options.Back_gradient_style
        Woofer_SPL_Chart.Palette = Main.BCD.Project.Chart_options.Line_palette

        For i = 0 To Woofer_SPL_Chart.Series.Count - 1
            Woofer_SPL_Chart.Series.Item(i).BorderWidth = Main.BCD.Project.Chart_options.Line_thickness
        Next

        Woofer_SPL_Chart.ChartAreas.Item(0).AxisX.MinorGrid.Enabled = Main.BCD.Project.Chart_options.X_Minor_Grid
        Woofer_SPL_Chart.ChartAreas.Item(0).AxisY.MinorGrid.Enabled = Main.BCD.Project.Chart_options.Y_Minor_Grid
        Woofer_SPL_Chart.ChartAreas.Item(0).AxisX.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.X_Axis_color_HTML)
        Woofer_SPL_Chart.ChartAreas.Item(0).AxisY.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Y_Axis_color_HTML)
        Woofer_SPL_Chart.ChartAreas.Item(0).AxisX.MinorGrid.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.X_MinorAxis_color_HTML)
        Woofer_SPL_Chart.ChartAreas.Item(0).AxisY.MinorGrid.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Y_MinorAxis_color_HTML)
    End Sub

    Public Sub Excursion_chart_init()
        'Initial chart appearance by copying from the stored data
        Excursion_Chart.ChartAreas.Item(0).Area3DStyle.Enable3D = Main.BCD.Project.Chart_options.Area3DStyle
        Excursion_Chart.ChartAreas.Item(0).Area3DStyle.Inclination = Main.BCD.Project.Chart_options.Inclination
        Excursion_Chart.ChartAreas.Item(0).Area3DStyle.Rotation = Main.BCD.Project.Chart_options.Rotation
        Excursion_Chart.ChartAreas.Item(0).Area3DStyle.PointDepth = Main.BCD.Project.Chart_options.PointDepth
        Excursion_Chart.ChartAreas.Item(0).BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.chart_back_color_HTML)
        Excursion_Chart.ChartAreas.Item(0).BackSecondaryColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.chart_sec_back_color_HTML)
        Excursion_Chart.ChartAreas.Item(0).BackGradientStyle = Main.BCD.Project.Chart_options.Chart_gradient_style
        Excursion_Chart.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Background_color_HTML)
        Excursion_Chart.BackSecondaryColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Sec_back_color_HTML)
        Excursion_Chart.BackGradientStyle = Main.BCD.Project.Chart_options.Back_gradient_style
        Excursion_Chart.Palette = Main.BCD.Project.Chart_options.Line_palette

        For i = 0 To Excursion_Chart.Series.Count - 1
            Excursion_Chart.Series.Item(i).BorderWidth = Main.BCD.Project.Chart_options.Line_thickness
        Next

        Excursion_Chart.ChartAreas.Item(0).AxisX.MinorGrid.Enabled = Main.BCD.Project.Chart_options.X_Minor_Grid
        Excursion_Chart.ChartAreas.Item(0).AxisY.MinorGrid.Enabled = Main.BCD.Project.Chart_options.Y_Minor_Grid
        Excursion_Chart.ChartAreas.Item(0).AxisX.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.X_Axis_color_HTML)
        Excursion_Chart.ChartAreas.Item(0).AxisY.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Y_Axis_color_HTML)
        Excursion_Chart.ChartAreas.Item(0).AxisX.MinorGrid.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.X_MinorAxis_color_HTML)
        Excursion_Chart.ChartAreas.Item(0).AxisY.MinorGrid.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Y_MinorAxis_color_HTML)
    End Sub

    Public Sub Impedance_chart_init()
        'Initial chart appearance by copying from the stored data
        Woofer_Impedance_Chart.ChartAreas.Item(0).Area3DStyle.Enable3D = Main.BCD.Project.Chart_options.Area3DStyle
        Woofer_Impedance_Chart.ChartAreas.Item(0).Area3DStyle.Inclination = Main.BCD.Project.Chart_options.Inclination
        Woofer_Impedance_Chart.ChartAreas.Item(0).Area3DStyle.Rotation = Main.BCD.Project.Chart_options.Rotation
        Woofer_Impedance_Chart.ChartAreas.Item(0).Area3DStyle.PointDepth = Main.BCD.Project.Chart_options.PointDepth
        Woofer_Impedance_Chart.ChartAreas.Item(0).BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.chart_back_color_HTML)
        Woofer_Impedance_Chart.ChartAreas.Item(0).BackSecondaryColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.chart_sec_back_color_HTML)
        Woofer_Impedance_Chart.ChartAreas.Item(0).BackGradientStyle = Main.BCD.Project.Chart_options.Chart_gradient_style
        Woofer_Impedance_Chart.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Background_color_HTML)
        Woofer_Impedance_Chart.BackSecondaryColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Sec_back_color_HTML)
        Woofer_Impedance_Chart.BackGradientStyle = Main.BCD.Project.Chart_options.Back_gradient_style
        Woofer_Impedance_Chart.Palette = Main.BCD.Project.Chart_options.Line_palette

        For i = 0 To Woofer_Impedance_Chart.Series.Count - 1
            Woofer_Impedance_Chart.Series.Item(i).BorderWidth = Main.BCD.Project.Chart_options.Line_thickness
        Next

        Woofer_Impedance_Chart.ChartAreas.Item(0).AxisX.MinorGrid.Enabled = Main.BCD.Project.Chart_options.X_Minor_Grid
        Woofer_Impedance_Chart.ChartAreas.Item(0).AxisY.MinorGrid.Enabled = Main.BCD.Project.Chart_options.Y_Minor_Grid
        Woofer_Impedance_Chart.ChartAreas.Item(0).AxisX.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.X_Axis_color_HTML)
        Woofer_Impedance_Chart.ChartAreas.Item(0).AxisY.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Y_Axis_color_HTML)
        Woofer_Impedance_Chart.ChartAreas.Item(0).AxisX.MinorGrid.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.X_MinorAxis_color_HTML)
        Woofer_Impedance_Chart.ChartAreas.Item(0).AxisY.MinorGrid.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Y_MinorAxis_color_HTML)

        Woofer_Impedance_Chart.Series.Item(0).BorderWidth = Main.BCD.Project.Chart_options.Line_thickness + 1

    End Sub

    Sub Power_Chart_init()
        Power_Chart.ChartAreas.Item(0).Area3DStyle.Enable3D = Main.BCD.Project.Chart_options.Area3DStyle
        Power_Chart.ChartAreas.Item(0).Area3DStyle.Inclination = Main.BCD.Project.Chart_options.Inclination
        Power_Chart.ChartAreas.Item(0).Area3DStyle.Rotation = Main.BCD.Project.Chart_options.Rotation
        Power_Chart.ChartAreas.Item(0).Area3DStyle.PointDepth = Main.BCD.Project.Chart_options.PointDepth
        Power_Chart.ChartAreas.Item(0).BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.chart_back_color_HTML)
        Power_Chart.ChartAreas.Item(0).BackSecondaryColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.chart_sec_back_color_HTML)
        Power_Chart.ChartAreas.Item(0).BackGradientStyle = Main.BCD.Project.Chart_options.Chart_gradient_style
        Power_Chart.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Background_color_HTML)
        Power_Chart.BackSecondaryColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Sec_back_color_HTML)
        Power_Chart.BackGradientStyle = Main.BCD.Project.Chart_options.Back_gradient_style
        Power_Chart.Palette = Main.BCD.Project.Chart_options.Line_palette

        For i = 0 To Power_Chart.Series.Count - 1
            Power_Chart.Series.Item(i).BorderWidth = Main.BCD.Project.Chart_options.Line_thickness
        Next

        Power_Chart.ChartAreas.Item(0).AxisX.MinorGrid.Enabled = Main.BCD.Project.Chart_options.X_Minor_Grid
        Power_Chart.ChartAreas.Item(0).AxisY.MinorGrid.Enabled = Main.BCD.Project.Chart_options.Y_Minor_Grid
        Power_Chart.ChartAreas.Item(0).AxisX.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.X_Axis_color_HTML)
        Power_Chart.ChartAreas.Item(0).AxisY.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Y_Axis_color_HTML)
        Power_Chart.ChartAreas.Item(0).AxisX.MinorGrid.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.X_MinorAxis_color_HTML)
        Power_Chart.ChartAreas.Item(0).AxisY.MinorGrid.LineColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Chart_options.Y_MinorAxis_color_HTML)

        Power_Chart.Series.Item(0).BorderWidth = Main.BCD.Project.Chart_options.Line_thickness + 1
    End Sub

#End Region

#Region "Painting (for Splice)"

    Private Sub Woofer_Splicebox_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Woofer_Splicebox.Paint

        Dim g As Graphics = e.Graphics

        Call Splice(Selected_Driver)
        'First find maximum and minimum of the Spliced_SPL data
        SPL_max = 0
        SPL_min = 10000
        For k = 0 To Main.Samples - 1
            If Spliced_SPL(Selected_Driver, k) > SPL_max Then SPL_max = Spliced_SPL(Selected_Driver, k)
            If Main.driver_data(Selected_Driver, 0, k) > SPL_max Then SPL_max = Main.driver_data(Selected_Driver, 0, k)
            If Spliced_SPL(Selected_Driver, k) < SPL_min Then SPL_min = Spliced_SPL(Selected_Driver, k)
            If Main.driver_data(Selected_Driver, 0, k) < SPL_min Then SPL_min = Main.driver_data(Selected_Driver, 0, k)
        Next

        Dim V, n, chart_mid_point As Integer

        If SPL_max = SPL_min Then SPL_min = SPL_max / 2 'just to avoid overflow during initialization
        Vert_scalefactor = Woofer_Splicebox.Height / (SPL_max - SPL_min)
        Horiz_scalefactor = Main.Samples / Woofer_Splicebox.Width
        Splice_freq_index = get_splice_index_from_freq(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Freq) / Horiz_scalefactor

        'Draw the Woofer amplitude (Benson Model)
        If Main.BCD.Spkr.driver1.TS_Parameters.Spliced Then
            chart_mid_point = Math.Round(get_splice_index_from_freq(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Freq) / Horiz_scalefactor)
        Else
            chart_mid_point = Woofer_Splicebox.Width - 1
        End If
        P1 = New Point(0, Woofer_Splicebox.Height - ((Spliced_SPL(Selected_Driver, 0) - SPL_min) * Vert_scalefactor - max_height_of_graph))
        For i = 1 To chart_mid_point
            n = Math.Round(i * Horiz_scalefactor)
            V = Woofer_Splicebox.Height - ((Spliced_SPL(Selected_Driver, n) - SPL_min) * Vert_scalefactor - max_height_of_graph)
            P2 = New Point(i, V)
            If mouse_over_woofer_ampl = True And i < Splice_freq_index - 2 Then
                pen = Woofer_SPL_highlight_pen
            Else
                pen = Woofer_SPL_normal_pen
            End If
            g.DrawLine(pen, P1, P2)
            P1 = P2
        Next

        'Draw the measurement amplitude
        If Main.BCD.Spkr.driver1.TS_Parameters.Spliced = False Then chart_mid_point = 0
        n = Math.Round(chart_mid_point * Horiz_scalefactor)
        P1 = New Point(chart_mid_point, Woofer_Splicebox.Height - ((Main.driver_data(Selected_Driver, 0, n) - SPL_min) * Vert_scalefactor - max_height_of_graph))
        For i = chart_mid_point + 1 To Woofer_Splicebox.Width - 1
            n = Math.Round(i * Horiz_scalefactor)
            V = Woofer_Splicebox.Height - ((Main.driver_data(Selected_Driver, 0, n) - SPL_min) * Vert_scalefactor - max_height_of_graph)
            P2 = New Point(i, V)
            g.DrawLine(Pens.Blue, P1, P2)
            P1 = P2
        Next

        'Draw the frequency bar
        Splice_box_left = Splice_freq_index - 2
        Splice_box_right = Splice_freq_index + 2
        If mouse_over_splice_box = True Then pen = Splice_box_highlight_pen Else pen = Splice_box_normal_pen
        g.DrawLine(pen, Splice_box_left, 0, Splice_box_right, 0)
        g.DrawLine(pen, Splice_box_left, 0, Splice_box_left, Woofer_Splicebox.Height - 1)
        g.DrawLine(pen, Splice_box_left, Woofer_Splicebox.Height - 1, Splice_box_right, Woofer_Splicebox.Height - 1)
        g.DrawLine(pen, Splice_box_right, 0, Splice_box_right, Woofer_Splicebox.Height - 1)
    End Sub

    Private Sub Mid1_Splicebox_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Mid1_Splicebox.Paint

        Dim g As Graphics = e.Graphics

        Call Splice(Selected_Driver)
        'First find maximum and minimum of the Spliced_SPL data
        SPL_max = 0
        SPL_min = 10000
        For i = 0 To Main.Samples - 1
            If Spliced_SPL(Selected_Driver, i) > SPL_max Then SPL_max = Spliced_SPL(Selected_Driver, i)
            If Main.driver_data(Selected_Driver, 0, i) > SPL_max Then SPL_max = Main.driver_data(Selected_Driver, 0, i)
            If Spliced_SPL(Selected_Driver, i) < SPL_min Then SPL_min = Spliced_SPL(Selected_Driver, i)
            If Main.driver_data(Selected_Driver, 0, i) < SPL_min Then SPL_min = Main.driver_data(Selected_Driver, 0, i)
        Next

        Dim V, n, chart_mid_point As Integer

        If SPL_max = SPL_min Then SPL_min = SPL_max / 2 'just to avoid overflow during initialization
        Vert_scalefactor = Mid1_Splicebox.Height / (SPL_max - SPL_min)
        Horiz_scalefactor = Main.Samples / Mid1_Splicebox.Width
        Splice_freq_index = get_splice_index_from_freq(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Freq) / Horiz_scalefactor

        'Draw the Woofer amplitude (Benson Model)
        If Main.BCD.Spkr.driver2.TS_Parameters.Spliced Then
            chart_mid_point = Math.Round(get_splice_index_from_freq(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Freq) / Horiz_scalefactor)
        Else
            chart_mid_point = Mid1_Splicebox.Width - 1
        End If
        P1 = New Point(0, Mid1_Splicebox.Height - ((Spliced_SPL(Selected_Driver, 0) - SPL_min) * Vert_scalefactor - max_height_of_graph))
        For i = 1 To chart_mid_point
            n = Math.Round(i * Horiz_scalefactor)
            V = Mid1_Splicebox.Height - ((Spliced_SPL(Selected_Driver, n) - SPL_min) * Vert_scalefactor - max_height_of_graph)
            P2 = New Point(i, V)
            If mouse_over_Mid1_ampl = True And i < Splice_freq_index - 2 Then
                pen = Woofer_SPL_highlight_pen
            Else
                pen = Woofer_SPL_normal_pen
            End If
            g.DrawLine(pen, P1, P2)
            P1 = P2
        Next

        'Draw the measurement amplitude
        If Main.BCD.Spkr.driver2.TS_Parameters.Spliced = False Then chart_mid_point = 0
        n = Math.Round(chart_mid_point * Horiz_scalefactor)
        P1 = New Point(chart_mid_point, Mid1_Splicebox.Height - ((Main.driver_data(Selected_Driver, 0, n) - SPL_min) * Vert_scalefactor - max_height_of_graph))
        For i = chart_mid_point + 1 To Mid1_Splicebox.Width - 1
            n = Math.Round(i * Horiz_scalefactor)
            V = Mid1_Splicebox.Height - ((Main.driver_data(Selected_Driver, 0, n) - SPL_min) * Vert_scalefactor - max_height_of_graph)
            P2 = New Point(i, V)
            g.DrawLine(Pens.Blue, P1, P2)
            P1 = P2
        Next

        'Draw the frequency bar
        Splice_box_left = Splice_freq_index - 2
        Splice_box_right = Splice_freq_index + 2
        If mouse_over_splice_box = True Then pen = Splice_box_highlight_pen Else pen = Splice_box_normal_pen
        g.DrawLine(pen, Splice_box_left, 0, Splice_box_right, 0)
        g.DrawLine(pen, Splice_box_left, 0, Splice_box_left, Mid1_Splicebox.Height - 1)
        g.DrawLine(pen, Splice_box_left, Mid1_Splicebox.Height - 1, Splice_box_right, Mid1_Splicebox.Height - 1)
        g.DrawLine(pen, Splice_box_right, 0, Splice_box_right, Mid1_Splicebox.Height - 1)
    End Sub

#End Region

#Region "Mouse Handlers (for Splice)"

    'Mouseover to detect whether we are in the splice box or the woofer response area
    Private Sub Woofer_Splicewindow_mouseover(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Woofer_Splicebox.MouseMove

        'No button depressed -- just enable higlighting or bounding boxes and let the Paint routine draw it
        If e.Button = Windows.Forms.MouseButtons.None Then

            'Check for frequency splice box
            If e.X >= Splice_freq_index - 2 And e.X <= Splice_freq_index + 2 Then
                mouse_over_splice_box = True
            Else
                mouse_over_splice_box = False
            End If

            'Check for woofer amplitude
            If e.X < Splice_freq_index - 2 Then
                mouse_over_woofer_ampl = True
            Else
                mouse_over_woofer_ampl = False
            End If

            'Common ending for no button pressed--just update the picturebox
            Woofer_Splicebox.Refresh()

        ElseIf e.Button = Windows.Forms.MouseButtons.Left Then

            If mouse_over_splice_box = True Then
                If e.X < 2 Then Exit Sub
                If e.X * Horiz_scalefactor >= Main.Samples Then Exit Sub
                Splice_freq_index = e.X
                Main.BCD.Spkr.driver1.TS_Parameters.Splice_Freq = get_splice_freq_from_index(Splice_freq_index)
                Woofer_splice_freq_textbox.Text = Str(Math.Round(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Freq))

                Call Update_Splice_estimate()
                Woofer_Splicebox.Refresh()          'calls Splice
            End If

            If mouse_over_woofer_ampl = True Then

                Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_added = get_splice_offset_from_index(e.Y)
                'Splice_offset = Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_calculated + Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_added
                Woofer_splice_offset_textbox.Text = Str(Math.Round(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_added, 1))

                Woofer_Splicebox.Refresh()  'calls Splice
            End If

        End If

    End Sub


    'Mouseover to detect whether we are in the splice box or the midrange response area
    Private Sub Mid1_Splicewindow_mouseover(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Mid1_Splicebox.MouseMove

        'No button depressed -- just enable higlighting or bounding boxes and let the Paint routine draw it
        If e.Button = Windows.Forms.MouseButtons.None Then

            'Check for frequency splice box
            If e.X >= Splice_freq_index - 2 And e.X <= Splice_freq_index + 2 Then
                mouse_over_splice_box = True
            Else
                mouse_over_splice_box = False
            End If

            'Check for midrange amplitude
            If e.X < Splice_freq_index - 2 Then
                mouse_over_Mid1_ampl = True
            Else
                mouse_over_Mid1_ampl = False
            End If

            'Common ending for no button pressed--just update the picturebox
            Mid1_Splicebox.Refresh()

        ElseIf e.Button = Windows.Forms.MouseButtons.Left Then

            If mouse_over_splice_box = True Then
                If e.X < 2 Then Exit Sub
                If e.X * Horiz_scalefactor >= Main.Samples Then Exit Sub
                Splice_freq_index = e.X
                Main.BCD.Spkr.driver2.TS_Parameters.Splice_Freq = get_splice_freq_from_index(Splice_freq_index)
                Mid1_splice_freq_textbox.Text = Str(Math.Round(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Freq))

                Call Update_Splice_estimate()
                Mid1_Splicebox.Refresh()     'calls Splice
            End If

            If mouse_over_Mid1_ampl = True Then

                Main.BCD.Spkr.driver2.TS_Parameters.Splice_Offset_added = get_splice_offset_from_index(e.Y)
                'Splice_offset = Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_calculated + Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_added
                Mid1_splice_offset_textbox.Text = Str(Math.Round(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Offset_added, 1))

                Mid1_Splicebox.Refresh()     'calls Splice
            End If

        End If

    End Sub

#End Region

#Region "Splice controls"

    Private Sub Woofer_Splice_CheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Woofer_Splice_CheckBox.CheckedChanged
        If Woofer_Splice_CheckBox.Checked Then
            Main.BCD.Spkr.driver1.TS_Parameters.Spliced = True
        Else
            Main.BCD.Spkr.driver1.TS_Parameters.Spliced = False
        End If
        Woofer_Splicebox.Refresh()    'calls Splice

    End Sub

    Private Sub Midrange_Splice_CheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Mid1_Splice_CheckBox.CheckedChanged
        If Mid1_Splice_CheckBox.Checked Then
            Main.BCD.Spkr.driver2.TS_Parameters.Spliced = True
        Else
            Main.BCD.Spkr.driver2.TS_Parameters.Spliced = False
        End If
        Mid1_Splicebox.Refresh()
    End Sub

    Private Sub Woofer_splice_freq_textbox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Woofer_splice_freq_textbox.TextChanged
        'Don't do anything if updated by another routine (initialization or loading textbook values)
        If Woofer_splice_freq_textbox.Focused Then
            If Val(Woofer_splice_freq_textbox.Text) > 0 And Val(Woofer_splice_freq_textbox.Text) < 10000 Then
                'If data is valid, enter it, else use old value
                If Val(Woofer_splice_freq_textbox.Text) >= 11 Then
                    Main.BCD.Spkr.driver1.TS_Parameters.Splice_Freq = Val(Woofer_splice_freq_textbox.Text)
                    Woofer_splice_freq_textbox.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Color_options.textbox_color_back_HTML)
                    Call Update_Splice_estimate()
                    Woofer_Splicebox.Refresh()
                    Woofer_splice_freq_textbox.Focus()
                Else
                    Woofer_splice_freq_textbox.BackColor = Color_Chooser.get_color_from_XML(Main.BCD.Project.Color_options.error_color_HTML)
                End If

            Else
                Woofer_splice_freq_textbox.Text = Math.Round(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Freq, 1)
                Woofer_splice_freq_textbox.Focus()
            End If
        End If
    End Sub

    Private Sub Woofer_splice_freq_textbox_Mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Woofer_splice_freq_textbox.MouseWheel
        Main.BCD.Spkr.driver1.TS_Parameters.Splice_Freq = Get_next_value(e.Delta, "F", Main.BCD.Spkr.driver1.TS_Parameters.Splice_Freq)
        Woofer_splice_freq_textbox.Text = Str(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Freq)
        Splice_freq_index = get_splice_index_from_freq(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Freq) / Horiz_scalefactor
        'Woofer_Splicebox.Refresh()
    End Sub

    Private Sub Woofer_splice_offset_textbox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Woofer_splice_offset_textbox.TextChanged
        'Don't do anything if updated by another routine (initialization or loading textbook values)
        If Woofer_splice_offset_textbox.Focused Then
            If Val(Woofer_splice_offset_textbox.Text) > -99 And Val(Woofer_splice_offset_textbox.Text) < 99 Then
                'If data is valid, enter it, else use old value
                Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_added = Val(Woofer_splice_offset_textbox.Text)
                Woofer_Splicebox.Refresh()
                Woofer_splice_offset_textbox.Focus()
            Else
                Woofer_splice_offset_textbox.Text = Math.Round(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_added, 1)
                Woofer_splice_offset_textbox.Focus()
            End If
        End If
    End Sub

    Private Sub Woofer_splice_offset_textbox_Mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Woofer_splice_offset_textbox.MouseWheel
        Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_added = Get_next_value(e.Delta, "O", Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_added)
        Woofer_splice_offset_textbox.Text = Str(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_added)
        Splice_freq_index = get_splice_index_from_freq(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_added) / Horiz_scalefactor
        'Woofer_Splicebox.Refresh()
    End Sub

    Private Sub Mid1_splice_freq_textbox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Mid1_splice_freq_textbox.TextChanged
        'Don't do anything if updated by another routine (initialization or loading textbook values)
        If Mid1_splice_freq_textbox.Focused Then
            If Val(Mid1_splice_freq_textbox.Text) > 0 And Val(Mid1_splice_freq_textbox.Text) < 10000 Then
                'If data is valid, enter it, else use old value
                Main.BCD.Spkr.driver2.TS_Parameters.Splice_Freq = Val(Mid1_splice_freq_textbox.Text)
                Call Update_Splice_estimate()
                Mid1_Splicebox.Refresh()
                Mid1_splice_freq_textbox.Focus()
            Else
                Mid1_splice_freq_textbox.Text = Math.Round(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Freq, 1)
                Mid1_splice_freq_textbox.Focus()
            End If
        End If
    End Sub

    Private Sub Mid1_splice_freq_textbox_Mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Mid1_splice_freq_textbox.MouseWheel
        Main.BCD.Spkr.driver2.TS_Parameters.Splice_Freq = Get_next_value(e.Delta, "F", Main.BCD.Spkr.driver2.TS_Parameters.Splice_Freq)
        Mid1_splice_freq_textbox.Text = Str(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Freq)
        Splice_freq_index = get_splice_index_from_freq(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Freq) / Horiz_scalefactor
        'Woofer_Splicebox.Refresh()
    End Sub

    Private Sub Mid1_splice_offset_textbox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Mid1_splice_offset_textbox.TextChanged
        'Don't do anything if updated by another routine (initialization or loading textbook values)
        If Mid1_splice_offset_textbox.Focused Then
            If Val(Mid1_splice_offset_textbox.Text) > -99 And Val(Mid1_splice_offset_textbox.Text) < 99 Then
                'If data is valid, enter it, else use old value
                Main.BCD.Spkr.driver2.TS_Parameters.Splice_Offset_added = Val(Mid1_splice_offset_textbox.Text)
                Mid1_Splicebox.Refresh()
                Mid1_splice_offset_textbox.Focus()
            Else
                Mid1_splice_offset_textbox.Text = Math.Round(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Offset_added, 1)
                Mid1_splice_offset_textbox.Focus()
            End If
        End If
    End Sub

    Private Sub Mid1_splice_offset_textbox_Mousewheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Mid1_splice_offset_textbox.MouseWheel
        Main.BCD.Spkr.driver2.TS_Parameters.Splice_Offset_added = Get_next_value(e.Delta, "O", Main.BCD.Spkr.driver2.TS_Parameters.Splice_Offset_added)
        Mid1_splice_offset_textbox.Text = Str(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Offset_added)
        Splice_freq_index = get_splice_index_from_freq(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Offset_added) / Horiz_scalefactor
        'Woofer_Splicebox.Refresh()
    End Sub

    'Mouse wheel support functions
    Function Get_next_value(ByVal mouse_direction, ByVal component_type, ByVal current_value)

        Select Case component_type

            Case "F"
                Get_next_value = splice_freq_values(0)
                If mouse_direction > 0 Then
                    For i = 0 To splice_freq_values.Length - 1
                        If splice_freq_values(i) > current_value Or i = splice_freq_values.Length - 1 Then
                            Get_next_value = splice_freq_values(i)
                            Exit For
                        End If
                    Next
                Else
                    For i = 0 To splice_freq_values.Length - 1
                        If current_value > splice_freq_values(i) Then
                            Get_next_value = splice_freq_values(i)
                        Else
                            Exit For
                        End If
                    Next
                End If

            Case "O"
                Get_next_value = splice_offset_values(0)
                If mouse_direction > 0 Then
                    For i = 0 To splice_offset_values.Length - 1
                        If splice_offset_values(i) > current_value Or i = splice_offset_values.Length - 1 Then
                            Get_next_value = splice_offset_values(i)
                            Exit For
                        End If
                    Next
                Else
                    For i = 0 To splice_offset_values.Length - 1
                        If current_value > splice_offset_values(i) Then
                            Get_next_value = splice_offset_values(i)
                        Else
                            Exit For
                        End If
                    Next
                End If

            Case Else
                Get_next_value = 0

        End Select

    End Function

#End Region

#Region "Splicing"

    Sub Update_Splice_estimate()
        'Update offset estimate used for splicing
        If Selected_Driver <> Selected_Woofer_box.what_if Then

            'First normalize the data using the measurement data at F=Splice_freq
            Dim Measurement_average, Response_average As Double
            Dim Splice_location As Integer
            Const averaging_window = 4

            'Box response is in Total_SPL(n);  Driver Response is in Main.driver_data(driver_index, Main.driver_FRDdata.Ampl, n)

            Measurement_average = 0
            Response_average = 0
            If Selected_Driver = Selected_Woofer_box.woofer Then
                Splice_location = get_splice_index_from_freq(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Freq) - averaging_window / 2
                For i = 0 To averaging_window - 1
                    Measurement_average = Measurement_average + Main.driver_data(Selected_Driver, 0, Splice_location + i)
                    Response_average = Response_average + Box_model.Total_SPL(Selected_Driver, Splice_location + i)
                Next
                Measurement_average = Measurement_average / averaging_window
                Response_average = Response_average / averaging_window
                Box_model.Driver1_calculated_offset = Measurement_average - Response_average
                Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_meas = Measurement_average

            ElseIf Selected_Driver = selected_Woofer_box.mid1 Then
                Splice_location = get_splice_index_from_freq(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Freq) - averaging_window / 2
                For i = 0 To averaging_window - 1
                    Measurement_average = Measurement_average + Main.driver_data(Selected_Driver, 0, Splice_location + i)
                    Response_average = Response_average + Box_model.Total_SPL(Selected_Driver, Splice_location + i)
                Next
                Measurement_average = Measurement_average / averaging_window
                Response_average = Response_average / averaging_window
                Box_model.Driver2_calculated_offset = Measurement_average - Response_average
                Main.BCD.Spkr.driver2.TS_Parameters.Splice_Offset_meas = Measurement_average

            End If

            Call Splice(Selected_Driver)
            'Flag to indicate the data is OK, even if the window has been closed
            Main.Splice_array_is_valid = True

        End If
    End Sub

    'This is where the spliced product is created
    Sub Splice(ByVal Driver_number)
        Dim scale_factor As Complex
        Dim scale_factor_temp As Double
        Dim temp As Integer

        Select Case Driver_number
            Case Selected_Woofer_box.woofer
                For n = 0 To Main.Samples - 1
                    Spliced_SPL(Driver_number, n) = Total_SPL(Driver_number, n) + Driver1_calculated_offset + Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_added
                Next

                'calculate offset for driver transfer function

                scale_factor_temp = Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_added + Main.BCD.Spkr.driver1.TS_Parameters.Splice_Offset_meas
                scale_factor = toComplex(10 ^ (scale_factor_temp / 20), 0)
                temp = Math.Round(get_splice_index_from_freq(Main.BCD.Spkr.driver1.TS_Parameters.Splice_Freq))
                scale_factor = scale_factor / Main.Arrays.Woofer.Modeled_Response(Driver_number, temp)  'normalize so response = 1 at splice point

                If Main.BCD.Spkr.driver1.TS_Parameters.Spliced Then

                    For n = 0 To temp
                        Main.Arrays.Driver_response.With_AC_offset_and_splice(Driver_number, n) = scale_factor * Main.Arrays.Woofer.Modeled_Response(Driver_number, n)
                    Next
                    For n = temp + 1 To Main.Samples - 1
                        Main.Arrays.Driver_response.With_AC_offset_and_splice(Driver_number, n) = Main.Arrays.Driver_response.With_AC_offset(Driver_number, n)
                    Next
                Else
                    For n = 0 To Main.Samples - 1
                        Main.Arrays.Driver_response.With_AC_offset_and_splice(Driver_number, n) = Main.Arrays.Driver_response.With_AC_offset(Driver_number, n)
                    Next
                End If

            Case Selected_Woofer_box.mid1
                For n = 0 To Main.Samples - 1
                    Spliced_SPL(Driver_number, n) = Total_SPL(Driver_number, n) + Driver2_calculated_offset + Main.BCD.Spkr.driver2.TS_Parameters.Splice_Offset_added
                Next

                'calculate offset for driver transfer function
                scale_factor_temp = Main.BCD.Spkr.driver2.TS_Parameters.Splice_Offset_added + Main.BCD.Spkr.driver2.TS_Parameters.Splice_Offset_meas
                scale_factor = toComplex(10 ^ (scale_factor_temp / 20), 0)
                temp = Math.Round(get_splice_index_from_freq(Main.BCD.Spkr.driver2.TS_Parameters.Splice_Freq))
                scale_factor = scale_factor / Main.Arrays.Woofer.Modeled_Response(Driver_number, temp) 'normalize so response = 1 at splice point

                If Main.BCD.Spkr.driver2.TS_Parameters.Spliced Then

                    For n = 0 To temp
                        Main.Arrays.Driver_response.With_AC_offset_and_splice(Driver_number, n) = scale_factor * Main.Arrays.Woofer.Modeled_Response(Driver_number, n)
                    Next
                    For n = temp + 1 To Main.Samples - 1
                        Main.Arrays.Driver_response.With_AC_offset_and_splice(Driver_number, n) = Main.Arrays.Driver_response.With_AC_offset(Driver_number, n)
                    Next
                Else
                    For n = 0 To Main.Samples - 1
                        Main.Arrays.Driver_response.With_AC_offset_and_splice(Driver_number, n) = Main.Arrays.Driver_response.With_AC_offset(Driver_number, n)
                    Next
                End If
        End Select

        If Main.PCD_window_open_flag = True Then
            Call Main.Recalc_Crossover()
        End If

    End Sub

    Function get_splice_freq_from_index(ByVal index)
        Dim n As Integer = 0
        n = Math.Round(index * Horiz_scalefactor)
        get_splice_freq_from_index = Main.Frequency(n)
    End Function

    Function get_splice_index_from_freq(ByVal freq)
        'Note the index returned is for main.samples (500) -- not the splice window size
        Dim save_index As Integer = 0
        For i = 0 To Main.Samples - 1
            If Main.Frequency(i) > freq Then
                save_index = i - 1
                Exit For
            End If
        Next
        get_splice_index_from_freq = save_index
    End Function

    Function get_splice_offset_from_index(ByVal Y)
        get_splice_offset_from_index = (Woofer_Splicebox.Height - Y) / Vert_scalefactor - max_height_of_graph
    End Function

#End Region

#Region "Printing and Image Save"

    Private Sub SPLToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SPLToolStripMenuItem.Click
        Dim filespec As String
        Dim get_file_name As New SaveFileDialog
        get_file_name.Filter = "JPG image |*.jpg"
        get_file_name.ShowDialog()
        filespec = get_file_name.FileName
        Woofer_SPL_Chart.SaveImage(filespec, DataVisualization.Charting.ChartImageFormat.Jpeg)
    End Sub

    Private Sub ExcursionToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExcursionToolStripMenuItem.Click
        Dim filespec As String
        Dim get_file_name As New SaveFileDialog
        get_file_name.Filter = "JPG image |*.jpg"
        get_file_name.ShowDialog()
        filespec = get_file_name.FileName
        Excursion_Chart.SaveImage(filespec, DataVisualization.Charting.ChartImageFormat.Jpeg)
    End Sub

    Private Sub ImpedanceToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ImpedanceToolStripMenuItem.Click
        Dim filespec As String
        Dim get_file_name As New SaveFileDialog
        get_file_name.Filter = "JPG image |*.jpg"
        get_file_name.ShowDialog()
        filespec = get_file_name.FileName
        Woofer_Impedance_Chart.SaveImage(filespec, DataVisualization.Charting.ChartImageFormat.Jpeg)
    End Sub

    Private Sub AmplifierPowerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AmplifierPowerToolStripMenuItem.Click
        Dim filespec As String
        Dim get_file_name As New SaveFileDialog
        get_file_name.Filter = "JPG image |*.jpg"
        get_file_name.ShowDialog()
        filespec = get_file_name.FileName
        Power_Chart.SaveImage(filespec, DataVisualization.Charting.ChartImageFormat.Jpeg)
    End Sub

    Private Sub PrintFormToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintFormToolStripMenuItem.Click
        CaptureScreen()
        PrintDocument1.Print()
    End Sub

    Private Sub printDocument1_PrintPage(ByVal sender As System.Object,
       ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles _
       PrintDocument1.PrintPage
        e.Graphics.DrawImage(memoryImage, 0, 0)
    End Sub

    Sub CaptureScreen()
        Dim myGraphics As Graphics = Me.CreateGraphics()
        Dim s As Size = Me.Size
        memoryImage = New Bitmap(s.Width, s.Height, myGraphics)
        Dim memoryGraphics As Graphics = Graphics.FromImage(memoryImage)
        memoryGraphics.CopyFromScreen(Me.Location.X, Me.Location.Y, 0, 0, s)

    End Sub

#End Region


    Private Sub Driver_database_button_Click(sender As System.Object, e As System.EventArgs) Handles Driver_database_button.Click
        Dim Driver_data_view As New Driver_dataview
        Main.Who_Called_the_Database = Main.Caller_enum.What_if
        Driver_data_view.ShowDialog()

    End Sub

End Class
